package ecp.vcs.com.ecpsyncplugin.re_sync;

import static ecp.vcs.com.ecpsyncplugin.EcpSyncPlugin.update_progress;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Binder;
import android.os.Build;
import android.os.Handler;
import android.os.IBinder;
import android.os.StrictMode;
import android.util.Log;

import androidx.annotation.Nullable;
import androidx.core.app.NotificationCompat;

import com.google.gson.Gson;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSyntaxException;
import com.google.gson.reflect.TypeToken;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import ecp.vcs.com.ecpsyncplugin.re_sync.database.DataBaseHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.database.DatabaseCRUD;
import ecp.vcs.com.ecpsyncplugin.re_sync.database.DatabaseHelperExtended;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopCFADispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.LanguageModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.sync.SyncUploadHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.authorization.Authentication;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Const;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Content;
import io.flutter.plugin.common.PluginRegistry;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

import ecp.vcs.com.ecpsyncplugin.R;
import ecp.vcs.com.ecpsyncplugin.re_sync.interfaces.DatabaseError;
import ecp.vcs.com.ecpsyncplugin.re_sync.interfaces.FileDownload;
import ecp.vcs.com.ecpsyncplugin.re_sync.interfaces.SyncUploadCallback;
import ecp.vcs.com.ecpsyncplugin.re_sync.interfaces.VolleyCallback;
import ecp.vcs.com.ecpsyncplugin.re_sync.logging.LogHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CreateNewCustomer;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoCMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoEMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CustomerTypeDetails;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.MenuAccess;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.PoliticalLevel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ScannedPoints;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.UserConfigurationMst;
import ecp.vcs.com.ecpsyncplugin.re_sync.networking.AppUtil;
import ecp.vcs.com.ecpsyncplugin.re_sync.networking.RestClient;
import ecp.vcs.com.ecpsyncplugin.re_sync.storage.ScopedStorage;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.DownloadFileFromURL;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.ErrorLogHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.SyncErrorCode;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.SyncFlag;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.ZipManager;
import ecp.vcs.com.ecpsyncplugin.re_sync.volley.VolleyHelper;


/**
 * Created by CHANDAN KUSHWAHA on 17/02/2020.
 */
public class SynchronizationService extends Service implements SyncUploadCallback,
        DatabaseError,
        FileDownload,
        VolleyCallback {

    private Timer mTimer1;
    private final Handler mTimerHandler = new Handler();
    private int mMin = 0;
    private int mMax = 0;

    private final IBinder mBinder = new LocalServiceBinder();
    //    For Notification
//    private NotificationCompat.Builder notificationBuilder;
//    private NotificationManager notificationManager;
    public static final int id = 1012;

    private DataBaseHelper dataBaseHelper;
    private DatabaseHelperExtended databaseHelperExtended;
    private DatabaseCRUD databaseCRUD;
    private final ZipManager zipManager = new ZipManager();
    private FileDownload fileDownload;

    private String tableName = "";
    public static String error_code = "";
//    public static String exceptionDetails = "";
    private final JSONObject objSyncData = new JSONObject();
    private JSONObject objTermsCondition;
    private String syncLogID = "";
    private String syncFileName = "";
    private boolean isTransactionSync;
    private boolean isMasterSync;
    private boolean isPointCalculationSync;
    private boolean isFirstSync;
    private long FD_start = 0;
    private long FUpload_Start = 0;
    private int totalProgress = 0;
    private String userManualLink = "";
    private String userFAQLink = "";
    private String is_faq_updated = "";
    private String is_manual_updated = "";
    private final boolean callCurrentPoint = true;
    int total_sync_stage = 0;
    int sync_stage = 1;
    int startProgress = 5;
    int endProgress = 5;

    PluginRegistry.Registrar registrar;

    public static boolean isSuccess = true;
    public static String exceptionDetails = "";
    public static String downloadFileSize = "";
    public static long UnZIP_Start = 0;
    public static long UnZIP_End = 0;

    public static String BASE_URL_PASS = "";
    public static String dateFolder = "";
    public static String userID;
    public static String encriptPassword;
    private String token;
    private String countryID;
    private String appVersion;
    private String appVersionCode;

    private String role_code;
    private String customer_level;

    private String CFA_DISPATCH;
    private String CFA_STOCK_TRANSFER;
    private String DIST_DISPATCH_MODEL;
    private String DIST_DISPATCH_MODEL_BASIC_SCAN;
    private String DIST_DISPATCH_MODEL_BASIC_SCAN_IDS;

//    SynchronizationService(PluginRegistry.Registrar reg,String baseURL,String uID,String tokenValue,
//                           String cID,String rCode,
//                           String cLevel,String cDispatch,String cStockTransfer,String cDistDispatchModel,String distDispatchBasicScan,
//                           String distDispatchBasicScanIDS){
//        registrar = reg;
//        BASE_URL_PASS = baseURL;
//        userID = uID;
//        token = tokenValue;
//        countryID = cID;
//        role_code = rCode;
//        customer_level = cLevel;
//        CFA_DISPATCH =cDispatch;
//        CFA_STOCK_TRANSFER = cStockTransfer;
//        DIST_DISPATCH_MODEL =cDistDispatchModel;
//        DIST_DISPATCH_MODEL_BASIC_SCAN = distDispatchBasicScan;
//        DIST_DISPATCH_MODEL_BASIC_SCAN_IDS = distDispatchBasicScanIDS;
//        dateFolder = "";
//    }


    @Override
    public void onCreate() {
        if (Build.VERSION.SDK_INT > 9) {
            StrictMode.ThreadPolicy policy =
                    new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);
        }
        super.onCreate();
        dataBaseHelper = DataBaseHelper.getInstance(this);
        databaseHelperExtended = new DatabaseHelperExtended(this);
        databaseCRUD = new DatabaseCRUD(this, this);
        DatabaseCRUD.open();
        fileDownload = this;
    }

    /**
     * Start Sync
     * Check If Transaction is Available in Local Device
     * If YES, then upload file for same and call Transaction WebService
     * If No, then Call Upload File without any File and Move to Next Step and Call Get Data Webservice
     */
    public void startSyncProcess(boolean isTransactionSyncs, boolean isMasterSyncs, boolean isPointCalculationSyncs,
                                 PluginRegistry.Registrar reg,String baseURL,String uID,String pass,String tokenValue,
                                 String cID,String rCode,
                                 String cLevel,String cDispatch,String cStockTransfer,String cDistDispatchModel,String distDispatchBasicScan,
                                 String distDispatchBasicScanIDS,String appVer,String appVerCode) {
        this.isTransactionSync = isTransactionSyncs;
        this.isMasterSync = isMasterSyncs;
        this.isPointCalculationSync = isPointCalculationSyncs;


        registrar = reg;
        BASE_URL_PASS = baseURL;
        userID = uID;
        encriptPassword = pass;
        token = tokenValue;
        countryID = cID;
        appVersion = appVer;
        appVersionCode = appVerCode;
        role_code = rCode;
        customer_level = cLevel;
        CFA_DISPATCH =cDispatch;
        CFA_STOCK_TRANSFER = cStockTransfer;
        DIST_DISPATCH_MODEL =cDistDispatchModel;
        DIST_DISPATCH_MODEL_BASIC_SCAN = distDispatchBasicScan;
        DIST_DISPATCH_MODEL_BASIC_SCAN_IDS = distDispatchBasicScanIDS;
        dateFolder = "";


        boolean isFirstSyncFlag = dataBaseHelper.getSyncDateAndTime() == null || dataBaseHelper.getSyncDateAndTime().isEmpty();
        if (isFirstSyncFlag) {
            this.isTransactionSync = false;
        }

        if (isTransactionSync && isMasterSync && isPointCalculationSync) {
            total_sync_stage = 3;
        } else if (isTransactionSync && isMasterSync) {
            total_sync_stage = 2;
        } else if (isTransactionSync && isPointCalculationSync) {
            total_sync_stage = 2;
        } else if (isMasterSync && isPointCalculationSync) {
            total_sync_stage = 2;
        } else {
            total_sync_stage = 1;
        }

        LogHelper.printLog("TAG_SYNC_DATA", "TOTAL SYNC STAGE:: " + total_sync_stage);

        showNotification();

        String location = "";
        if (isTransactionSync) {
            LogHelper.printLog("TAG_SYNC_DATA", "INSIDE TRANSACTION");
            boolean isLocalTransactionAvailable = false;
            if (checkIfTransactionExists()) {
                isLocalTransactionAvailable = true;
                location = getLocalTransactionFile("T");
                if (location.equalsIgnoreCase(String.valueOf(SyncErrorCode.ERROR_102))
                        || location.equalsIgnoreCase(SyncErrorCode.ERROR_CODE_311)) {
                    updateActivity();
                } else {
                    LogHelper.printLog("TAG_SYNC_DATA", "LOCAL DEVICE DATA EXISTS");
                    uploadFileToServer(location, "T", 2, 50);
                }
            } else if (isMasterSync) {
                isLocalTransactionAvailable = false;
                location = getLocalTransactionFile("G");
                if (location.equalsIgnoreCase(String.valueOf(SyncErrorCode.ERROR_102))
                        || location.equalsIgnoreCase(SyncErrorCode.ERROR_CODE_311)) {
                    updateActivity();
                } else {
                    LogHelper.printLog("TAG_SYNC_DATA", "LOCAL DEVICE DATA NOT AVAILABLE");
                    uploadFileToServer(location, "G", 2, 50);
                }
            } else if (isPointCalculationSyncs) {
                isLocalTransactionAvailable = false;
                location = getLocalTransactionFile("P");
                if (location.equalsIgnoreCase(String.valueOf(SyncErrorCode.ERROR_102))
                        || location.equalsIgnoreCase(SyncErrorCode.ERROR_CODE_311)) {
                    updateActivity();
                } else {
                    LogHelper.printLog("TAG_SYNC_DATA", "LOCAL DEVICE DATA NOT AVAILABLE");
                    uploadFileToServer(location, "P", 2, 50);
                }

            }
        } else {
            LogHelper.printLog("TAG_SYNC_DATA", "INSIDE POINT CALCULATION");
            if (isMasterSync) {
                location = getLocalTransactionFile("G");
                if (location.equalsIgnoreCase(String.valueOf(SyncErrorCode.ERROR_102))
                        || location.equalsIgnoreCase(SyncErrorCode.ERROR_CODE_311)) {
                    updateActivity();
                } else {
                    uploadFileToServer(location, "G", 2, 50);
                }

            } else if (isPointCalculationSync) {
                location = getLocalTransactionFile("P");
                if (location.equalsIgnoreCase(String.valueOf(SyncErrorCode.ERROR_102))
                        || location.equalsIgnoreCase(SyncErrorCode.ERROR_CODE_311)) {
                    updateActivity();
                } else {
                    uploadFileToServer(location, "P", 2, 50);
                }
            }
        }

    }


    /**
     * Get Local Zipped File With Transaction Data
     *
     * @return
     */
    private String getLocalTransactionFile(String sync_type) {
        String zipped_file_name = "";
        try {
            String requestData = "";
            if (sync_type.equalsIgnoreCase("G")) {
                requestData = databaseCRUD.getSynchronizationMaster();
            } else {
                requestData = databaseCRUD.getSynchronization();
            }


            long FG_Start = System.currentTimeMillis();
            String requestFileName = AppUtil.getRequestFileName(registrar.activity(),"userID");
            LogHelper.printLog("SYNC_REQUEST", "REQUEST::: " + requestFileName);
            String generatedFilePath = AppUtil.generateNoteOnSDForAll(requestFileName, requestData, SynchronizationService.this, databaseHelperExtended,userID);

            long FG_End = System.currentTimeMillis();
            long difference = AppUtil.getMillisDifference(FG_Start, FG_End);
            objSyncData.put("FG", difference);
//            generatedFilePath=null;
            if (generatedFilePath != null) {
                File file = new File(generatedFilePath);
                if (file.exists()) {
                    long ZIP_Start = System.currentTimeMillis();
                    String zipFileName = AppUtil.getFileName(requestFileName);
                    String toLocation = ScopedStorage.getInstance(this).getPath(ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST) + "/" + zipFileName + zipManager.ZIP_EXTENSION;
                    zipManager.zipFileAtPath(generatedFilePath, toLocation);

                    long ZIP_End = System.currentTimeMillis();
                    difference = AppUtil.getMillisDifference(ZIP_Start, ZIP_End);
                    Log.v("SYNCTRACK", "ZP_ TIME::" + AppUtil.getMillisDifference(ZIP_Start, ZIP_End));
                    objSyncData.put("ZP", difference);

                    zipped_file_name = toLocation;

                } else {
                    error_code = String.valueOf(SyncErrorCode.ERROR_103);
                    exceptionDetails = SyncErrorCode.SYNC_ERROR_MSG_103;
                    updateActivity();
                }
            } else {
                error_code = String.valueOf(SyncErrorCode.ERROR_102);
                exceptionDetails = SyncErrorCode.SYNC_ERROR_MSG_102;
//                updateActivity();
                return String.valueOf(SyncErrorCode.ERROR_102);
            }
        } catch (JSONException e) {
            e.printStackTrace();
            databaseHelperExtended.insertTransactionErrorLog(this, this.getClass().getSimpleName(),
                    "startSync",
                    AppUtil.getStackTrace(e),
                    AppUtil.getStackTrace(e),
                    SyncErrorCode.ERROR_CODE_311, syncLogID,userID);

            return SyncErrorCode.ERROR_CODE_311;
        }

        return zipped_file_name;
    }

    /**
     * Upload File to server
     *
     * @param filePath
     */
    private void uploadFileToServer(String filePath, String uploadType, int startProgress, int endProgress) {
        SyncUploadHelper uploadHelper = new SyncUploadHelper(this, this);
//        Const.BASE_URL = Content.getPreferenceValue(this, Const.new_base_url);
//        if (Const.BASE_URL.isEmpty()) {
//            Const.BASE_URL = AppUtil.getBaseURL(SynchronizationService.this);
//        }
        String uploadUrl = BASE_URL_PASS + Const.WEB_SERVICES_URL.WS_SYNCHRONIZATION_UPLOAD_FILE_ANDROID;
        if (AppUtil.isNetworkConnected(this)) {
            FUpload_Start = System.currentTimeMillis();

            uploadHelper.uploadFileWithType(filePath, uploadUrl, uploadType, startProgress, endProgress,"","",AppUtil.getIMEINo(registrar.context()),userID);

        } else {
//            AppUtil.DisplayNetworkAlertMessage(this);
        }
    }

    /**
     * Check If transaction is Available
     *
     * @return
     */
    private boolean checkIfTransactionExists() {
        JSONObject obj;
        try {
            obj = new JSONObject(databaseCRUD.getSynchronization());
            if (!hasData(obj)) {
                return false;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return true;
    }

    /**
     * Check if Any Transaction is done
     *
     * @param obj
     * @return
     */
    private boolean hasData(JSONObject obj) {
        boolean hasData = false;
        if (obj != null) {
            Iterator<String> iter = obj.keys();
            while (iter.hasNext()) {
                String key = iter.next();
                Log.v("KEY_JSON", key);
                try {
                    if (!key.equalsIgnoreCase("table_device_token")) {
                        Object value = obj.get(key);
                        if (value instanceof JSONArray) {
                            JSONArray array = (JSONArray) obj.get(key);
                            if (array != null && array.length() > 0) {
                                hasData = true;
                                break;
                            }
                            Log.v("KEY_JSON_VALUE", array.toString());
                        }
                    }

                } catch (JSONException e) {
                    // Something went wrong!
                }
            }
        }
        return hasData;
    }

    /**
     * Show Local Notification
     */
    public void showNotification() {
        Intent myPendingIntent = new Intent(this, registrar.activity().getClass());
        myPendingIntent.putExtra("isFromSync", true);
        myPendingIntent.putExtra("isSyncCompleted", false);
        PendingIntent pendingIntent = PendingIntent.getActivity(this,
                0,
                myPendingIntent,
                PendingIntent.FLAG_IMMUTABLE | PendingIntent.FLAG_UPDATE_CURRENT);

        String CHANNEL_ID = "channel_RE_CPM_01";
//        notificationBuilder = new NotificationCompat.Builder(this, CHANNEL_ID)
//                .setSmallIcon(AppUtil.getNotificationIcon())
//                .setContentTitle("Sync Data")
//                .setContentText("Sync Processing")
//                .setAutoCancel(false)
//                .setOngoing(true)
//                .setSound(null)
//                .setPriority(NotificationCompat.PRIORITY_MAX)
//                .setContentIntent(pendingIntent);

//        notificationBuilder = new NotificationCompat.Builder(this, CHANNEL_ID)
//                .setContentTitle("Sync Data")
//                .setContentText("Sync Processing")
//                .setAutoCancel(false)
//                .setOngoing(true)
//                .setSound(null)
//                .setPriority(NotificationCompat.PRIORITY_MAX)
//                .setContentIntent(pendingIntent);

//        notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);

        // Android O requires a Notification Channel.
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            CharSequence name = getString(R.string.app_name);
//            CharSequence name = getString(R.string.app_name);
            // Create the channel for the notification
            NotificationChannel iosChannel = new NotificationChannel(CHANNEL_ID, "Sync", NotificationManager.IMPORTANCE_DEFAULT);
            // Set the Notification Channel for the Notification Manager.
            iosChannel.enableLights(true);
            iosChannel.enableVibration(false);
            iosChannel.setLightColor(Color.GRAY);
            iosChannel.setSound(null, null);
            iosChannel.setLockscreenVisibility(Notification.VISIBILITY_PUBLIC);


//            notificationManager.createNotificationChannel(iosChannel);
        }
//        notificationManager.notify(id, notificationBuilder.build());
    }

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return mBinder;
    }


    /**
     * On Database Error
     *
     * @param error_codes
     * @param message
     */
    @Override
    public void onDatabaseError(String error_codes, String message) {
        exceptionDetails = message;
        error_code = error_codes;

        fireError();
    }

    /**
     * File Download Callback
     *
     * @param response
     */
    @Override
    public void onFileDownloadSuccess(String response, String sync_type) {
        try {
//            stopTimer();

            if (response != null) {
                objSyncData.put("DownloadFileSize", downloadFileSize + "KB");
                final String path = ScopedStorage.getInstance(this).getPath(ScopedStorage.EXTERNAL_STORAGE_SYNC_RESPONSE_DEV) + "/";
                processDownloadData(path, syncFileName, FD_start, sync_type);
            } else {
                exceptionDetails = exceptionDetails + "";
                error_code = "107";
                fireError();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    @Override
    public void onManualFileDownloadSuccess(String filePath, boolean hideLoader) {

    }

    @Override
    public void onFileDownloadFailure() {
//        stopTimer();
//        error_code = HomeActivity.error_code;
//        exceptionDetails = HomeActivity.exceptionDetails;
        updateActivity();
    }

    @Override
    public void onManualFileDownloadFailure() {
//        stopTimer();
    }


    /**
     * File upload Callback
     *
     * @param fileName
     * @param syncLogId
     * @param fileUploadTime
     * @param uploadFileSize
     * @param uploadType
     */
    @Override
    public void onFileUploadSuccess(String fileName,
                                    String syncLogId,
                                    String fileUploadTime,
                                    String uploadFileSize,
                                    String uploadType) {
        try {
//            increaseTimmer(50, 349);
            syncLogID = syncLogId;
            syncFileName = fileName;
            long FUpload_End = System.currentTimeMillis();
            long difference = AppUtil.getMillisDifference(FUpload_Start, FUpload_End);
            Log.v("SYNCTRACK", "UFS_ TIME::" + difference);
            objSyncData.put("UFS", difference);
            objSyncData.put("filename", fileName);
            objSyncData.put("UploadFileSize", uploadFileSize + "KB");

            if (AppUtil.isNetworkConnected(this)) {
                if (uploadType.equalsIgnoreCase("G")) {
                    // Added For New File Name For Reference to G Type of Sync
                    syncFileName = AppUtil.getRequestFileName(registrar.activity(),"userID");
                }
                callSyncAPI(syncFileName, syncLogId, uploadType);
            } else {
//                AppUtil.DisplayNetworkAlertMessage(this);
            }
        } catch (JSONException e) {
            e.printStackTrace();
            databaseHelperExtended.insertTransactionErrorLog(this, this.getClass().getSimpleName(),
                    "onFileUploadSuccess",
                    AppUtil.getStackTrace(e),
                    AppUtil.getStackTrace(e),
                    SyncErrorCode.ERROR_CODE_312, syncLogID,userID);
        }
    }

    @Override
    public void onProgressUpdate(int progress) {
        updateNotificationProgress(progress);
//        String response = "FLAG!!"+SyncFlag.FLAG_UPLOAD_FAIL
//                + "||"
//                +"errorCode!!"+errorCode
//                + "||"
//                +"errorMsg!!"+errorMsg
//                + "||"
//                +"objProcess!!"+objSyncData
//                + "||"
//                +"syncLogID!!"+syncLogID;
        sendBroadCastDetails(444, "Progress@@"+progress, progress);

    }

    private void sendBroadCastDetails(int type, String details, int progress) {
        //type = 1 => progress, 2 => errors, 3 => sync complate
        Log.e("sendBroadCastDetails", "sendBroadCastDetails");
        Intent intent = new Intent(update_progress);
        intent.putExtra("type", type);
        intent.putExtra("progress", progress);
        intent.putExtra("details", details);
        this.registrar.context().sendBroadcast(intent);
    }

    @Override
    public void onFileUploadFail(int errorCode,
                                 String errorMsg,
                                 String uploadFileSize,
                                 String uploadType) {

        try {
//            stopTimer();
            objSyncData.put("UploadFileSize", uploadFileSize + "KB");
            if (mBinder.isBinderAlive()) {
                Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
                intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
                intent.putExtra("FLAG", SyncFlag.FLAG_UPLOAD_FAIL);
                intent.putExtra("errorCode", String.valueOf(errorCode));
                intent.putExtra("errorMsg", errorMsg);
                intent.putExtra("objProcess", objSyncData.toString());
                intent.putExtra("syncLogID", syncLogID);

                String response = "FLAG!!"+SyncFlag.FLAG_UPLOAD_FAIL
                        + "||"
                        +"errorCode!!"+errorCode
                        + "||"
                        +"errorMsg!!"+errorMsg
                        + "||"
                        +"objProcess!!"+objSyncData
                        + "||"
                        +"syncLogID!!"+syncLogID;
                sendBroadCastDetails(555, "Fail@@"+response, 0);

                sendBroadcast(intent);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }

    }


    /**
     * Call Sync Webservice
     *
     * @param fileName
     * @param syncLogId
     */
    private void callSyncAPI(String fileName, String syncLogId, String syncType) {

        final long SYNC_API_start = System.currentTimeMillis();
        fileName = fileName.replace(".zip", "");
        fileName = fileName.replace(".txt", "");
        syncFileName = fileName;
        Log.e("TAG_SYNC_FILE_NAME", fileName);
        if (dataBaseHelper == null)
            dataBaseHelper = new DataBaseHelper(this);

        isFirstSync = dataBaseHelper.getSyncDateAndTime() == null || dataBaseHelper.getSyncDateAndTime().isEmpty();


        JSONObject objData = Authentication.getInstance(this).getSyncDataNew(fileName, syncLogId, this, syncType);
        JSONObject requestParam = Authentication.getInstance(this).getRequestParam(Authentication.getInstance(this).getAuth(countryID,userID,encriptPassword,appVersion,appVersionCode), objData);

        String url = BASE_URL_PASS + Const.WEB_SERVICES_URL.WS_SYNCHRONIZATION_NEW;
        LogHelper.printLog("REQUEST", "SYNC REQUEST URL::: " + url);
        LogHelper.printLog("REQUEST", "SYNC LOG ID::: " + syncLogId);
        LogHelper.printLog("REQUEST_SYNC_TYPE", "SYNC LOG ID::: " + syncType);

        String lastDate = "";
        if (syncType.equalsIgnoreCase("G")) {
            lastDate = databaseHelperExtended.getSyncDateAndTime();
        } else {
            lastDate = databaseHelperExtended.getTransactionSyncDateAndTime();
        }

        VolleyHelper volleyHelper = new VolleyHelper(this, this, syncType);
        JSONObject objParam = new JSONObject();
        try {
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_USER_ID, userID);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_COUNTRY_ID, countryID);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_FILE_NAME, fileName);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_sync_date, lastDate);
//            objParam.put(Const.WEB_SERVICES_PARAM.date_folder, Content.getPreferenceValue(this, Const.dateUpload));
            objParam.put(Const.WEB_SERVICES_PARAM.date_folder, SynchronizationService.dateFolder);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_VERSION, appVersion);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_IMEI, AppUtil.getIMEINo(this));
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_VERSION_CODE, appVersionCode);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_SYNC_LOG_ID, syncLogId);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_SYNC_TYPE, syncType);

//            if (!Content.getPreferenceValue(this, Content.SYNC_TYPE).isEmpty()) {
//                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, Content.getPreferenceValue(this, Content.SYNC_TYPE));
//            } else {
//                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, "H");
//            }

            if (!syncType.isEmpty()) {
                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, syncType);
            } else {
                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, "H");
            }

            objParam.put(Const.WEB_SERVICES_PARAM.KEY_REQUEST_PARAM, requestParam.toString());

            LogHelper.printLog("TAG_SYNC_DATA", "SYNC REQUEST::: " + objParam);

        } catch (JSONException e) {
            e.printStackTrace();
        }
        volleyHelper.postStringRequest(url, objParam, SYNC_API_start, VolleyHelper.SYNC_REQUEST_CODE);
        sync_stage += 1;
    }


    /**
     * Check Stages of SYNC
     */
    private void checkSyncStage(String sync_type) {
        if (total_sync_stage == 3) {
            LogHelper.printLog("SYNC_STAGE", "STAGES::: " + 3);
            if (sync_stage == 1) {
                startProgress = 50;
                endProgress = 133;
            } else if (sync_stage == 2) {
                startProgress = 134;
                endProgress = 266;
            } else if (sync_stage == 3) {
                startProgress = 266;
                endProgress = 349;
            }
        } else if (total_sync_stage == 2) {
            LogHelper.printLog("SYNC_STAGE", "STAGES::: " + 2);
            if (sync_stage == 1) {
                startProgress = 50;
                endProgress = 133;
            } else if (sync_stage == 2) {
                startProgress = 5;
                endProgress = 133;
            }
        } else {
            LogHelper.printLog("SYNC_STAGE", "STAGES::: " + 1);
            if (sync_stage == 1) {
                if (sync_type.equalsIgnoreCase("G")) {
                    startProgress = 50;
                    endProgress = 100;
                } else if (sync_type.equalsIgnoreCase("T")) {
                    startProgress = 50;
                    endProgress = 200;
                } else if (sync_type.equalsIgnoreCase("P")) {
                    startProgress = 50;
                    endProgress = 200;
                }
            }
        }
    }

    /**
     * Call Sync Webservice
     *
     * @param fileName
     * @param syncLogId
     */
    private void callSchemeAPIPoint(String fileName, String syncLogId, String syncType) {
        final long SYNC_API_start = System.currentTimeMillis();
        fileName = fileName.replace(".zip", "");
        syncFileName = fileName;
        Log.e("TAG_SYNC_FILE_NAME", fileName);
        if (dataBaseHelper == null)
            dataBaseHelper = new DataBaseHelper(this);

        isFirstSync = dataBaseHelper.getSyncDateAndTime() == null || dataBaseHelper.getSyncDateAndTime().isEmpty();

//        int startProgress = 350;
//        int endProgress = 390;
//
//        increaseTimmer(startProgress, endProgress);

        JSONObject objData = Authentication.getInstance(this).getSyncDataNew(fileName, syncLogId, this, syncType);
        JSONObject requestParam = Authentication.getInstance(this).getRequestParam(Authentication.getInstance(this).getAuth(countryID,userID,encriptPassword,appVersion,appVersionCode), objData);

        String url = BASE_URL_PASS + Const.WEB_SERVICES_URL.WS_SYNCHRONIZATION_NEW;
        LogHelper.printLog("REQUEST", "SYNC REQUEST URL::: " + url);
        LogHelper.printLog("REQUEST", "SYNC LOG ID::: " + syncLogId);

        VolleyHelper volleyHelper = new VolleyHelper(this, this, syncType);
        JSONObject objParam = new JSONObject();
        try {
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_USER_ID, userID);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_COUNTRY_ID, countryID);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_FILE_NAME, fileName);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_sync_date, dataBaseHelper.getSyncDateAndTime());
//            objParam.put(Const.WEB_SERVICES_PARAM.date_folder, Content.getPreferenceValue(this, Const.dateUpload));
            objParam.put(Const.WEB_SERVICES_PARAM.date_folder, SynchronizationService.dateFolder);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_VERSION, appVersion);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_IMEI, AppUtil.getIMEINo(this));
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_VERSION_CODE, appVersionCode);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_SYNC_LOG_ID, syncLogId);
            objParam.put(Const.WEB_SERVICES_PARAM.KEY_SYNC_TYPE, syncType);

//            if (!Content.getPreferenceValue(this, Content.SYNC_TYPE).isEmpty()) {
//                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, Content.getPreferenceValue(this, Content.SYNC_TYPE));
//            } else {
//                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, "H");
//            }

            if (!syncType.isEmpty()) {
                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, syncType);
            } else {
                objParam.put(Const.WEB_SERVICES_PARAM.KEY_FLAG, "H");
            }

            objParam.put(Const.WEB_SERVICES_PARAM.KEY_REQUEST_PARAM, requestParam.toString());

            LogHelper.printLog("TAG_SYNC_DATA", "SCHEME REQUEST::: " + objParam.toString());

        } catch (JSONException e) {
            e.printStackTrace();
        }
        volleyHelper.postStringRequest(url, objParam, SYNC_API_start, VolleyHelper.SYNC_REQUEST_CODE);
    }


    /**
     * Volley Response Callback
     *
     * @param objectResponse
     * @param startTime
     * @param requestCode    T- Transaction
     *                       G- Get Data
     *                       P- Point Calculation
     *                       I- Scheme
     */
    @Override
    public void onResponseSuccess(JSONObject objectResponse,
                                  long startTime,
                                  int requestCode, String syncType) {

//        stopTimer();

        LogHelper.printLog("TAG_SYNC_DATA", "RESPONSE::" + objectResponse);
        LogHelper.printLog("TAG_SYNC_DATA", "SYNC_TYPE::" + syncType);

        if (objectResponse.optBoolean("status")) {
            String lang_code = objectResponse.optString("lang_code");
            updateLanguage(lang_code);
        }

        if (requestCode == VolleyHelper.SYNC_REQUEST_CODE) {
            if (syncType.equalsIgnoreCase("T")) {
                try {
                    if (objectResponse.getBoolean("status")) {

                        if (customer_level.equalsIgnoreCase("L4") && !role_code.equalsIgnoreCase("FO")) {
                            //For WareHouse
                            handleResponseForTransaction(objectResponse, startTime, syncType);
                        } else {
                            callSyncAPI(syncFileName, syncLogID, "I");
                        }
                    } else {
                        LogHelper.printLog("TAG_SYNC_DATA", "SYNC_ERROR::" + objectResponse.getString("msg_code"));
                        error_code = objectResponse.getString("msg_code");
                        exceptionDetails = objectResponse.getString("message");
                        updateActivity();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            } else if (syncType.equalsIgnoreCase("G")) {
                if (objectResponse != null) {
                    error_code = "";
                    Log.e("SYNC_REQUEST", "MASTER RESPONSE ::" + objectResponse.toString());
                    try {

                        //BD URL
                        String announcement_count = objectResponse.optString("announcement_count");
//                        Content.setPreferenceValue(SynchronizationService.this, Const.NOTIFICATION_COUNT, announcement_count);


                        if (objectResponse.getBoolean("status")) {

                            int startProgress = 100;
                            int endProgress = 250;

//                                if (isLocalTransactionAvailable) {
//                                    startProgress = 200;
//                                    endProgress = 300;
//                                } else {
//                                    startProgress = 100;
//                                    endProgress = 250;
//                                }

//                                increaseTimmer(startProgress, endProgress);

                            long SYNC_API_end = System.currentTimeMillis();
                            long difference = AppUtil.getMillisDifference(startTime, SYNC_API_end);
                            Log.v("SYNCTRACK", "SAPI_ TIME::" + difference);
                            objSyncData.put("SAPI", difference);
                            syncLogID = objectResponse.optString("sync_log_id");
                            LogHelper.printLog("SYNC_LOG_ID_SYNC", "SYNC LOG ID::: " + syncLogID);


                            //BD URL
                            if (!objectResponse.optString("kyc_url").isEmpty()) {
//                                Content.setPreferenceValue(SynchronizationService.this, Const.KYC_URL, objectResponse.optString("kyc_url"));
                            }

                            if (!objectResponse.optString("filename").isEmpty()) {
                                syncFileName = objectResponse.getString("filename");
                            }
                            String fileDownloadUrl = objectResponse.getString("download_url");

                            if (objectResponse.has("user_manual_url")) {
                                userManualLink = objectResponse.getString("user_manual_url");
                                userFAQLink = objectResponse.getString("user_faq_url");
                                is_faq_updated = objectResponse.getString("is_faq_updated");
                                is_manual_updated = objectResponse.getString("is_manual_updated");
                            }
                            FD_start = System.currentTimeMillis();
                            new DownloadFileFromURL(SynchronizationService.this, syncFileName, fileDownload, syncType).execute(fileDownloadUrl);
                        } else {
                            String msg_code = objectResponse.optString("msg_code");
                            if (objectResponse.has("isLoginCheck")) {
                                if (objectResponse.getInt("isLoginCheck") == 0) {
                                    error_code = "212";
                                    exceptionDetails = objectResponse.getString("message");
                                    updateActivity();
                                } else {
                                    objTermsCondition = new JSONObject();
                                    objTermsCondition = objectResponse;
                                    if (objectResponse.has("filename")) {
                                        syncFileName = objectResponse.getString("filename");
                                    }
                                    msg_code = objectResponse.optString("msg_code");
                                    error_code = msg_code;
                                    exceptionDetails = objectResponse.getString("message");

                                    if (!msg_code.trim().isEmpty() && msg_code.equalsIgnoreCase(SyncErrorCode.UPDATE_VERSION)) {

                                        showMessageForVersionUpdate(msg_code, objectResponse.getString("message"), objectResponse.getString("link"));

                                    } else {
                                        String terms_condition = objectResponse.optString("terms_condition_url");
                                        if (terms_condition != null && !terms_condition.isEmpty()) {
                                            showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 1, objTermsCondition);
                                        } else {
                                            showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 2, objTermsCondition);
                                        }
                                    }

                                }
//                                stopTimer();
                            } else if (msg_code.equalsIgnoreCase("501")
                                    || msg_code.equalsIgnoreCase("213")
                                    || msg_code.equalsIgnoreCase("503")) {
                                error_code = msg_code;
                                exceptionDetails = objectResponse.getString("message");
                                updateActivity();

//                                stopTimer();
                            } else {
                                objTermsCondition = new JSONObject();
                                objTermsCondition = objectResponse;
                                if (objectResponse.has("filename")) {
                                    syncFileName = objectResponse.getString("filename");
                                }
                                msg_code = objectResponse.optString("msg_code");
                                error_code = msg_code;
                                exceptionDetails = objectResponse.getString("message");

                                if (!msg_code.trim().isEmpty() && msg_code.equalsIgnoreCase(SyncErrorCode.UPDATE_VERSION)) {

                                    showMessageForVersionUpdate(msg_code, objectResponse.getString("message"), objectResponse.getString("link"));

                                } else {
                                    //                        For Terms and Conditions
                                    String terms_condition = objectResponse.optString("terms_condition_url");
                                    if (terms_condition != null && !terms_condition.isEmpty()) {
                                        showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 1, objTermsCondition);
                                    } else {
                                        showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 2, objTermsCondition);
                                    }
                                }

//                                stopTimer();
                            }

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        error_code = String.valueOf(SyncErrorCode.ERROR_105_1);
                        exceptionDetails = AppUtil.getStackTrace(e);
                        updateActivity();
//                        stopTimer();
                    }
                } else {
                    error_code = String.valueOf(SyncErrorCode.ERROR_105_2);
                    exceptionDetails = "Invalid JSON Response";
                    updateActivity();
//                    stopTimer();
                }
            } else if (syncType.equalsIgnoreCase("P")) {

                //For Scheme Calculation
                //No Need to Handle Response
//                stopTimer();
                updateNotificationProgress(395);
                LogHelper.printLog("TAG_SYNC_DATA", "TYPE::" + objectResponse);
                try {
                    if (objectResponse != null) {
                        if (objectResponse.getBoolean("status")) {
                            String message = objectResponse.getString("message");
                            updateNotificationProgress(398);
                            callGetUserCurrentPointsAPI(true);
                            LogHelper.printLog("TAG_SYNC_DATA", "TYPE::" + message);
                        } else {
                            LogHelper.printLog("TAG_SYNC_DATA", "SYNC_ERROR::" + objectResponse.getString("msg_code"));
                            error_code = objectResponse.getString("msg_code");
                            exceptionDetails = objectResponse.getString("message");
                            updateActivity();
                        }
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            } else if (syncType.equalsIgnoreCase("I")) {
                LogHelper.printLog("TAG_SYNC_DATA", "TYPE::" + objectResponse);
                try {
                    if (objectResponse != null) {
                        if (objectResponse.getBoolean("status")) {
                            String message = objectResponse.getString("message");
                            handleResponseForTransaction(objectResponse, startTime, syncType);
                            LogHelper.printLog("TAG_SYNC_DATA", "TYPE::" + message);
                        } else {
                            LogHelper.printLog("TAG_SYNC_DATA", "SYNC_ERROR::" + objectResponse.getString("msg_code"));
                            error_code = objectResponse.getString("msg_code");
                            exceptionDetails = objectResponse.getString("message");
                            updateActivity();
                        }
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        }
    }


    @Override
    public void onResponseFail(String error) {
//        stopTimer();
        LogHelper.printLog("TAG_SYNC_DATA", "SYNC_ERROR::" + error);
        error_code = String.valueOf(SyncErrorCode.ERROR_106);
        exceptionDetails = error;
        String response = "FLAG!!"+SyncFlag.FLAG_ERROR
                + "||"
                +"errorCode!!"+error_code
                + "||"
                +"errorMsg!!"+exceptionDetails
                + "||"
                +"objProcess!!"+objSyncData
                + "||"
                +"syncLogID!!"+syncLogID;
        sendBroadCastDetails(555, "Fail@@"+response, 0);
        updateActivity();
    }


    /**
     * Process Download
     *
     * @param path
     * @param downloadFileName
     * @param FD_start
     */
    private void processDownloadData(String path, final String downloadFileName, final long FD_start, String sync_type) {
        try {
            Log.v("TAG_SYNC_DATA", "  onCompleted called");

            long differenceExtract = AppUtil.getMillisDifference(UnZIP_Start, UnZIP_End);
            Log.v("SYNCTRACK", "UZP_ TIME::" + differenceExtract);
            objSyncData.put("UZP", differenceExtract);
            Log.v("TAG_SYNC_DATA", "  onCompleted called");
            long FD_End = System.currentTimeMillis();
            long difference = AppUtil.getMillisDifference(FD_start, FD_End);
            objSyncData.put("FD", difference);

//            stopTimer();
            new InsertData(downloadFileName, sync_type).execute();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    private class InsertData extends AsyncTask<String, String, String> {


        private final String downloadFileName;
        private final String sync_type;

        public InsertData(String downloadFileName, String sync_type) {
            this.downloadFileName = downloadFileName;
            this.sync_type = sync_type;
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                if (sync_type.equalsIgnoreCase("G")) {
                    //For Master Sync
                    saveMasterData(downloadFileName);
                } else if (sync_type.equalsIgnoreCase("T") || sync_type.equalsIgnoreCase("I")) {
                    if (role_code.equalsIgnoreCase("FO")) {
                        // For Employee same as Retailer
                        saveRetailerTransactionData(downloadFileName);
                    } else if (customer_level.equalsIgnoreCase("L4")) {
                        //For Warehouse
                        saveWHTransactionData(downloadFileName);
                    } else if (customer_level.equalsIgnoreCase("L3")) {
                        // For Distributor
                        saveDistributorTransactionData(downloadFileName);
                    } else if (customer_level.equalsIgnoreCase("L2")) {
                        // For Retailer
                        saveRetailerTransactionData(downloadFileName);
                    }

                }

            } catch (Exception e) {
                e.printStackTrace();
                return null;
            }
            return "done";
        }

        @Override
        protected void onPostExecute(String flag) {
            super.onPostExecute(flag);

        }
    }


    /**
     * Move to Home Screen when Terms and Condition is Available
     *
     * @param terms_condition flag=1 for terms and Condition
     *                        flag=2 for Sync Status fail
     */
    private void showTermsInHomeActivity(String terms_condition, String errorMsg, int flag, JSONObject objTermsConditionDetails) {
        try {
            ErrorLogHelper.writeToFileMain(exceptionDetails, appVersion, this);
            Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
            intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
            if (flag == 1) {
                intent.putExtra("FLAG", SyncFlag.FLAG_TERMS_AND_CONDITIONS);
                intent.putExtra("objUserDetails", objTermsConditionDetails.toString());
            } else {
                intent.putExtra("FLAG", SyncFlag.FLAG_STATUS_FAIL_MSG);
            }
            intent.putExtra("errorCode", error_code);
            intent.putExtra("errorMsg", errorMsg);
            intent.putExtra("termsCondition", terms_condition);
            intent.putExtra("objProcess", objSyncData.toString());
            intent.putExtra("syncLogID", syncLogID);
            intent.putExtra("status", false);
            sendBroadcast(intent);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Method For Version Check and Update
     *
     * @param msg_code
     * @param message
     * @param apkDownloadLink
     */
    private void showMessageForVersionUpdate(String msg_code, String message, String apkDownloadLink) {
        Log.v("DOWNLOAD", apkDownloadLink);
        try {
//            if (notificationBuilder != null) {
//                notificationBuilder.setContentTitle(message);
//                notificationBuilder.setContentText("");
//                if (notificationManager != null)
//                    notificationBuilder.setProgress(0, 0, false);
//                notificationManager.notify(id, notificationBuilder.build());
//            }
            ErrorLogHelper.writeToFileMain(exceptionDetails, appVersion, this);
            Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
            intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
            intent.putExtra("FLAG", SyncFlag.FLAG_UPDATE_APP);
            intent.putExtra("errorCode", msg_code);
            intent.putExtra("errorMsg", message);
            intent.putExtra("termsCondition", "");
            intent.putExtra("objProcess", objSyncData.toString());
            intent.putExtra("syncLogID", syncLogID);
            intent.putExtra("status", false);
            intent.putExtra("link", apkDownloadLink);
            sendBroadcast(intent);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Method to Insert Error Log in TransactionErrorLog Table
     */
    private void updateActivity() {
        try {
            databaseHelperExtended.insertTransactionErrorLog(SynchronizationService.this, this.getClass().getSimpleName(), "updateActivity", exceptionDetails, exceptionDetails, error_code, syncLogID,userID);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (mBinder.isBinderAlive()) {
            if (!error_code.trim().isEmpty()) {
//                if (notificationBuilder != null) {
//                    notificationBuilder.setContentTitle(getString(R.string.syncfail) + getString(R.string.errorcode) + error_code);
//                    notificationBuilder.setContentText("");
//                    Content.setPreferenceValue(this, Content.SYNC_PROCESS, false);
//                    if (notificationManager != null) {
//                        notificationBuilder.setProgress(0, 0, false);
//                        notificationManager.notify(id, notificationBuilder.build());
//                    }
//                }
            }

            fireError();

        }
    }

    /**
     * Update Notification progress
     *
     * @param progress
     */
    public void updateNotificationProgress(int progress) {

        try {
            if (AppUtil.isNetworkConnected(this)) {
                totalProgress = progress;
                updateActivitySyncProgress(progress);
            } else {
//                stopTimer();
                error_code = String.valueOf(SyncErrorCode.ERROR_110);
                exceptionDetails = getString(R.string.no_internet);
                updateActivity();
                LogHelper.printLog("INTERNET_CHECK", "DISCONNECTED");
            }
        } catch (Exception e) {
            e.printStackTrace();
            LogHelper.printLog("TAG_M_PERCENT", "ERROR" + e.getMessage());
        }
    }

    /**
     * Updating Progress in Sync Activity with
     * Progressbar
     *
     * @param progress
     */
    private void updateActivitySyncProgress(int progress) {
        if (mBinder.isBinderAlive()) {

            Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
            intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
            intent.putExtra("FLAG", SyncFlag.FLAG_PROGRESS_UPDATE);
            if (progress == 400) {
                String response = "FLAG!!"
                        + "||"
                        +"errorCode!!"
                        + "||"
                        +"errorMsg!!"
                        + "||"
                        +"objProcess!!"+objSyncData
                        + "||"
                        +"syncLogID!!"+syncLogID
                        + "||"
                        +"manuals!!"+userManualLink + "::" + userFAQLink + "::" + is_faq_updated + "::" + is_manual_updated;
                sendBroadCastDetails(666, "Fail@@"+response, 100);
                sendBroadCastDetails(444, "Progress@@"+100, 100);
                intent.putExtra("errorCode", "200");
            } else {
                sendBroadCastDetails(444, "Progress@@"+progress, progress);
                intent.putExtra("errorCode", "");
            }
            intent.putExtra("errorMsg", "");
            intent.putExtra("syncLogID", syncLogID);
            intent.putExtra("percent", progress);
            intent.putExtra("objProcess", objSyncData.toString());
            intent.putExtra("manuals", userManualLink + "::" + userFAQLink + "::" + is_faq_updated + "::" + is_manual_updated);
            sendBroadcast(intent);
        }

        if (progress == 400) {
//            Handler handler = new Handler(Looper.getMainLooper());
//            handler.post(() -> ToastHelper.quickToast(SynchronizationService.this, getString(R.string.syncsuccessfullydone)));
//            Content.setPreferenceValue(this, "SYNC_SERVICE", "SYNC STOP");
//            notificationBuilder.setContentTitle(getString(R.string.syncsuccessfullydone));
//            notificationBuilder.setContentText("");
//            notificationManager.cancel(id);
        }

    }


    /**
     * Class used for the client Binder.  Because we know this service always
     * runs in the same process as its clients, we don't need to deal with IPC.
     */
    public class LocalServiceBinder extends Binder {
        public SynchronizationService getService() {
            // Return this instance of LocalService so clients can call public methods
            return SynchronizationService.this;
        }
    }


    /**
     * Save Data to Database
     * Only For Transaction
     */
    private void saveWHTransactionData(String downloadFileName) {
        try {

            long ExtractProcess_start = System.currentTimeMillis();
            int totalRecords = 0;
            long SDT_start = System.currentTimeMillis();
            String jsonString;
            File f = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            LogHelper.printLog("TAG_FILE", "FILE::: " + DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            if (f.exists()) {
                LogHelper.printLog("TAG_FILE", "FILE::: " + f.getAbsolutePath());
                jsonString = DownloadFileFromURL.readTextFile(f.getPath());

                if (!jsonString.equalsIgnoreCase("")) {
                    JSONObject objectResponse = new JSONObject(jsonString);
                    if (objectResponse.getBoolean("status")) {

                        if (objectResponse.has("Last_Sync_Date_Time")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Last_Sync_Date_Time");
                            databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 1);
                        }

                        if (objectResponse.has("isKYCDone")) {
                            String isKYCDone = objectResponse.getString("isKYCDone");
//                            Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
                        }
//                        databaseCRUD.DumpDetails();
                    }
                    publishProgress(69);


                    File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
                    boolean stickerDetailsStart = false;
                    if (dir.exists() && dir.isDirectory()) {
                        String[] dirs = dir.list();
                        for (String items : dirs) {
                            Log.v("FILE TRACK", " DIRECTORY::" + items);
                            File file = new File(dir.getAbsolutePath() + "/" + items);
                            if (file.isDirectory()) {
                                String[] subDirs = file.list();
                                int count = 92;
                                for (String item : subDirs) {
                                    if (totalProgress < 350) {
                                        totalProgress = totalProgress + 1;
                                    }
                                    Log.v("FILE TRACK", " FILE::" + items);
                                    File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);

                                    if (tempFile.exists()) {
                                        jsonString = DownloadFileFromURL.readTextFile(tempFile.getPath());
                                    }
                                    if (item.equalsIgnoreCase("1.txt")) {
                                        totalRecords = 1;
                                    }
                                    objectResponse = new JSONObject(jsonString);

                                    if (objectResponse.has("ishop_sticker_details")) {
                                        if (!stickerDetailsStart) {
                                            stickerDetailsStart = true;
                                            SDT_start = System.currentTimeMillis();
                                            Log.e("CheckLog", "start" + SDT_start);
                                        }
                                        tableName = getString(R.string.ishopstickerdetails);
                                        ++count;
                                        if (count == 100) {
                                            count = count - 1;
                                        }
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        Log.e("CheckLog", "total" + totalRecords);
                                        DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                                customer_level,role_code);
                                    } else if (objectResponse.has("ishop_cfa_dispatch_product")) {
                                        tableName = getString(R.string.cfadispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(70);
                                        //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                        databaseCRUD.InsertCFADispatchProductNew1(jsonArrayEmployee);

                                    } else if (objectResponse.has("ishop_sample_dispatch_product")) {
                                        tableName = getString(R.string.cfadispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(71);
                                        if (role_code.equalsIgnoreCase("FO")) {
                                            databaseHelperExtended.deleteSampleProductTable();
                                        }
                                        databaseCRUD.InsertSampleFocDispatchProduct(jsonArrayEmployee);

                                    } else if (objectResponse.has("ishop_sticker")) {
                                        tableName = getString(R.string.ishopsticker);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(72);
                                        if (role_code.equalsIgnoreCase("FO")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else if (customer_level.equalsIgnoreCase("L2")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else {
                                            databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                        }
                                    } else if (objectResponse.has("ishop_toller_dispatch")) {
                                        tableName = getString(R.string.tollerdispatch);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(73);
                                        DatabaseCRUD.InsertTollerDispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_toller_dispatch_product")) {
                                        tableName = getString(R.string.tollerdispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(74);
                                        databaseCRUD.InsertTollerDispatchProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("ishop_cfa_dispatch")) {
                                        tableName = getString(R.string.cfadispatch);
                                        publishProgress(75);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(75);
                                        databaseCRUD.InsertCFADispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_sample_dispatch")) {
                                        tableName = getString(R.string.cfadispatch);
                                        publishProgress(76);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(76);
                                        if (role_code.equalsIgnoreCase("FO")) {
                                            databaseHelperExtended.deleteSampleMainTable();
                                        }
                                        databaseCRUD.InsertSampleFocDispatchMain(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("cpm_customer_product_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(77);
                                        databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                        databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        publishProgress(78);
                                        JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                        databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                                    } else if (objectResponse.has("ishop_distributor_return_request_product")) {
                                        tableName = getString(R.string.distributorreturnrequestproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        if (customer_level.equalsIgnoreCase("L4")) {
                                            databaseCRUD.InsertDistributorReturnRequestProductNew(jsonArrayEmployee);
                                        } else {
                                            databaseCRUD.InsertDistributorReturnRequestProductNewForDist(jsonArrayEmployee);
                                        }
                                    } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                        tableName = getString(R.string.distributordispatch);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(79);
                                        //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("extra_sticker_detail")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                                    } else if (objectResponse.has("ishop_pallet_details")) {
                                        JSONArray jsonArrayPallet = objectResponse.getJSONArray("ishop_pallet_details");
                                        totalRecords = totalRecords + jsonArrayPallet.length();
                                        if (jsonArrayPallet.length() > 0) {
                                            databaseCRUD.insertPalletDetails(jsonArrayPallet, dataBaseHelper.getLoginId(),customer_level,role_code);
                                        }
                                    } else if (objectResponse.has("ishop_extra_pallet_detail")) {
                                        JSONArray palletExtraStickerDetail = objectResponse.getJSONArray("ishop_extra_pallet_detail");
                                        totalRecords = totalRecords + palletExtraStickerDetail.length();
                                        databaseCRUD.InsertPalletExtraStickerDetail(palletExtraStickerDetail);
                                    } else if (objectResponse.has("bf_scm_cpm_integration_data")) {
                                        JSONArray bfScmList = objectResponse.getJSONArray("bf_scm_cpm_integration_data");
                                        totalRecords = totalRecords + bfScmList.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.insertScmData(bfScmList);
                                    } else if (objectResponse.has("ishop_cfa_return_product")) {
                                        JSONArray cfaReturnProductArray = objectResponse.getJSONArray("ishop_cfa_return_product");
                                        totalRecords = totalRecords + cfaReturnProductArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertCFAReturnProductBulk(cfaReturnProductArray);
                                    } else if (objectResponse.has("ishop_cfa_return")) {
                                        JSONArray cfaReturnArray = objectResponse.getJSONArray("ishop_cfa_return");
                                        totalRecords = totalRecords + cfaReturnArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertCFAReturnBulk(cfaReturnArray);
                                    } else if (objectResponse.has("ishop_distributor_return_request")) {
                                        JSONArray distReturnRequestArray = objectResponse.getJSONArray("ishop_distributor_return_request");
                                        totalRecords = totalRecords + distReturnRequestArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertDistributorReturnRequestBulk(distReturnRequestArray);
                                    }

                                }
                            }
                        }
                    }


                    if (!error_code.trim().isEmpty()) {
                        updateActivity();
                        return;
                    }

                    dataBaseHelper.deleteSaveOfflineLogTable();
                    databaseCRUD.deleteUnreceivedValidData();
                    databaseCRUD.deleteRejectedOrder();
                    dataBaseHelper.deleteDamageData();
                    databaseCRUD.deleteDeviceTokenTable();
                    databaseHelperExtended.deleteRejectedData();
                    dataBaseHelper.deleteCfaDispatchIDNotInProductTable();
                    databaseHelperExtended.deleteCfaDispatchIDNotInMainTable();
                    databaseHelperExtended.deleteTransactionErrorLog();
                    insertDelayedTransaction();

                    DatabaseHelperExtended databaseHelperExtended = new DatabaseHelperExtended(this);
                    databaseHelperExtended.updateRetailerReceiveProductSyncFlag();
                    databaseHelperExtended.updateRetailerDispatchProductSyncFlag();

                    if (customer_level.equalsIgnoreCase("L3")) {
                        databaseHelperExtended.deleteDistributorReturnRequestData(userID);
                    }

                    long SDT_End = System.currentTimeMillis();
                    try {
                        long difference = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        Log.v("SYNCTRACK", "SDT_ TIME::" + difference);
                        objSyncData.put("SDT", "" + difference);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    long ExtractProcess_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(ExtractProcess_start, ExtractProcess_end);
                    Log.v("SYNCTRACK", "SYPR_ TIME::" + difference);

                    try {
                        long differenceStickerTable = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        long totalRemaining = difference - differenceStickerTable;
                        objSyncData.put("SYPR", totalRemaining);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

//                    stopTimer();

                    if (customer_level.equalsIgnoreCase("L4") && !role_code.equalsIgnoreCase("FO")) {
                        updateNotificationProgress(400);
                    } else {
                        if (isPointCalculationSync) {
                            LogHelper.printLog("TAG_SYNC_DATA", "CALL POINT CALC Webservice");
                            callSchemeAPIPoint(syncFileName, syncLogID, "P");
                        } else {
                            callGetUserCurrentPointsAPI(true);
                        }
                    }
                }


            } else {
                exceptionDetails = "Download File do not exist.";
                error_code = "108";
//                stopTimer();

                fireError();
            }
        } catch (JSONException e) {
            e.printStackTrace();
//            stopTimer();
            exceptionDetails = AppUtil.getStackTrace(e);
            error_code = "108";

            fireError();
        }
    }

    /**
     * Save Data to Database
     */
    private void saveMasterData(String downloadFileName) {
        try {
            long ExtractProcess_start = System.currentTimeMillis();
            int totalRecords = 0;
            long SDT_start = System.currentTimeMillis();
            File f = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            LogHelper.printLog("TAG_FILE", "FILE::: " + DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            if (f.exists()) {
                LogHelper.printLog("TAG_FILE", "FILE::: " + f.getAbsolutePath());
                String jsonString = DownloadFileFromURL.readTextFile(f.getPath());

//                JsonObject obj=new JsonParser().parse(DownloadFileFromURL.readTextFile(f.getPath())).getAsJsonObject();
//                saveTempMasterData(obj,downloadFileName,SDT_start);
                if (jsonString != null && !jsonString.isEmpty()) {
                    JSONObject objectResponse = new JSONObject(jsonString);
                    if (objectResponse.getBoolean("status")) {

                        if (objectResponse.has("master_new_customer")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("master_new_customer");
                            Type listType = new TypeToken<ArrayList<CreateNewCustomer>>() {
                            }.getType();
                            List<CreateNewCustomer> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCustomer.clear();
                            DatabaseCRUD.arrayListCustomer.addAll(arrayListTollerDispatchProduct);
                        }
                        tableName = getString(R.string.retailerdispatch);
                        publishProgress(60);
                        if (objectResponse.has("ishop_retailer_dispatch")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch");
                            databaseCRUD.InsertRetailerDispatchNew(jsonArrayEmployee);
                        }

                        tableName = getString(R.string.distributorreturn);
                        publishProgress(61);
                        if (objectResponse.has("ishop_distributor_return")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return");
                            databaseCRUD.InsertDistributorReturnNew(jsonArrayEmployee);
                        }

                        tableName = getString(R.string.distributorreturnrequest);
                        publishProgress(62);

                        tableName = getString(R.string.menuaccess);
                        publishProgress(62);
                        if (objectResponse.has("Menu_Access")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Menu_Access");
                            Type listType = new TypeToken<ArrayList<MenuAccess>>() {
                            }.getType();
                            List<MenuAccess> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListMenuAccess.clear();
                            DatabaseCRUD.arrayListMenuAccess.addAll(arrayListTollerDispatchProduct);
                        }

                        tableName = getString(R.string.politicallevel);
                        publishProgress(63);
                        if (objectResponse.has("Political_Level")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Level");
                            Type listType = new TypeToken<ArrayList<PoliticalLevel>>() {
                            }.getType();
                            List<PoliticalLevel> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListPoliticalLevel.clear();
                            DatabaseCRUD.arrayListPoliticalLevel.addAll(arrayListEmployee);
                        }

                        tableName = getString(R.string.distributorreceived);
                        publishProgress(64);
                        if (objectResponse.has("ishop_distributor_received")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received");
                            databaseCRUD.InsertDistributorReceivedNew(jsonArrayEmployee);
                        }
                        tableName = getString(R.string.distributorreceivedproduct);
                        publishProgress(64);
                        if (objectResponse.has("ishop_distributor_received_product")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                            databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                        }
                        tableName = getString(R.string.retailerreceived);
                        publishProgress(65);

                        if (objectResponse.has("ishop_customer_scaned_in_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_in_sticker");
                            Type listType = new TypeToken<ArrayList<ScannedPoints>>() {
                            }.getType();
                            List<ScannedPoints> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListScannedPoints.clear();
                            DatabaseCRUD.arrayListScannedPoints.addAll(arrayListEmployee);
                        }


                        //Used in Both Retailer and Distributor
                        if (objectResponse.has("ishop_customer_scaned_out_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_out_sticker");
                            databaseCRUD.insertRetailerScannedOutSticker(jsonArrayEmployee);
                        }

                        tableName = "ctocmapping";
                        publishProgress(66);
                        //CtoCMapping
                        if (objectResponse.has("ctocmapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ctocmapping");
                            Type listType = new TypeToken<ArrayList<CtoCMapping>>() {
                            }.getType();
                            List<CtoCMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCtoCMapping.clear();
                            DatabaseCRUD.arrayListCtoCMapping.addAll(arrayListEmployee);
                        }

                        if (objectResponse.has("ctoemapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ctoemapping");
                            Type listType = new TypeToken<ArrayList<CtoEMapping>>() {
                            }.getType();
                            List<CtoEMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCtoEMapping.clear();
                            DatabaseCRUD.arrayListCtoEMapping.addAll(arrayListEmployee);
                        }

                        if (objectResponse.has("user_configuration_mst")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("user_configuration_mst");
                            Type listType = new TypeToken<ArrayList<UserConfigurationMst>>() {
                            }.getType();
                            List<UserConfigurationMst> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            Log.e("userConfigList", "" + arrayListEmployee);
                            Log.e("userConfigList", "" + jsonArrayEmployee);
                            DatabaseCRUD.arrayListUserConfigurationMst.clear();
                            DatabaseCRUD.arrayListUserConfigurationMst.addAll(arrayListEmployee);
                        }
                        //
                        if (objectResponse.has("Last_Sync_Date_Time")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Last_Sync_Date_Time");
                            databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 2);
//                            Content.setPreferenceValue(SynchronizationService.this, Content.LAST_SYNC_DATE, jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                        }
                        //table CustomerType_Details
                        if (objectResponse.has("CustomerType_Details")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("CustomerType_Details");
                            Type listType = new TypeToken<ArrayList<CustomerTypeDetails>>() {
                            }.getType();
                            List<CustomerTypeDetails> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCustomerType_Details.clear();
                            DatabaseCRUD.arrayListCustomerType_Details.addAll(arrayListEmployee);
                        }
                        tableName = getString(R.string.employeeretailer);
                        publishProgress(67);
                        if (objectResponse.has("etormapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("etormapping");
                            databaseCRUD.InsertETORMAPPINGNew(jsonArrayEmployee);
                        }
                        if (objectResponse.has("rtormapping")) {
                            JSONArray jsonArrayRtoRMapping = objectResponse.getJSONArray("rtormapping");
                            databaseCRUD.InsertRtoRMappingNew(jsonArrayRtoRMapping);
                        }
                        if (objectResponse.has("dtormapping")) {
                            JSONArray jsonArrayDtoRMapping = objectResponse.getJSONArray("dtormapping");
                            databaseCRUD.InsertDtoRMappingNew(jsonArrayDtoRMapping);
                        }

                        //DP-30707,DP-30708
                        if (objectResponse.has("lookup_values_config")) {
                            JSONArray arrayLookupConfig = objectResponse.optJSONArray("lookup_values_config");
                            if (arrayLookupConfig != null && arrayLookupConfig.length() > 0) {
                                databaseCRUD.InsertLookUpValuesConfig(arrayLookupConfig);
                            } else {
                                databaseCRUD.deleteLookUpTable();
                            }
                        } else {
                            databaseCRUD.deleteLookUpTable();
                        }

                        //DP-30707,DP-30708
                        if (objectResponse.has("sku_wise_blocking_period_details")) {
                            JSONArray arrayskuwiseblock = objectResponse.optJSONArray("sku_wise_blocking_period_details");
                            if (arrayskuwiseblock != null && arrayskuwiseblock.length() > 0) {
                                databaseCRUD.InsertSkuWiseBlockDetails(arrayskuwiseblock);
                            } else {
                                databaseCRUD.deleteBlockDetailsTable();
                            }
                        } else {
                            databaseCRUD.deleteBlockDetailsTable();
                        }


                        databaseCRUD.DumpEmployeeDetails();

                        if (objectResponse.has("isKYCDone")) {
                            Log.d("KYCVAL==", objectResponse.getString("isKYCDone"));
                            String isKYCDone = objectResponse.getString("isKYCDone");
//                            Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
                        }
                    }
                    publishProgress(69);

                    tableName = "VIDEO Detail";
                    if (objectResponse.has("User_Help_Video")) {
                        JSONArray jsonArrayVideo = objectResponse.getJSONArray("User_Help_Video");
                        databaseCRUD.InsertHelpVideoData(jsonArrayVideo, dataBaseHelper.getLoginId(),countryID);
                    }
                    tableName = DataBaseHelper.TABLE_MASTER_REASON;
                    if (objectResponse.has("master_reason")) {
                        JSONArray jsonArrayMasterReason = objectResponse.getJSONArray("master_reason");
                        databaseCRUD.insertMasterReason(jsonArrayMasterReason);
                    }
                    File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
                    boolean stickerDetailsStart = false;
                    if (dir.exists() && dir.isDirectory()) {
                        String[] dirs = dir.list();
                        for (String items : dirs) {
                            Log.v("FILE_TRACK", " DIRECTORY::" + items);
                            File file = new File(dir.getAbsolutePath() + "/" + items);
                            if (file.isDirectory()) {
                                String[] subDirs = file.list();
                                int count = 92;
                                try {
                                    for (String item : subDirs) {
                                        if (totalProgress < 350) {
                                            totalProgress = totalProgress + 1;
                                        }

                                        Log.v("FILE_TRACK", " FILE::" + items);
                                        File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);
                                        Log.v("FILE_TRACK", " FILE::" + tempFile.getAbsolutePath());
                                        String jsonReadText = "";
                                        if (tempFile.exists()) {
                                            jsonReadText = DownloadFileFromURL.readTextFile(tempFile.getPath());
                                        }
                                        if (item.equalsIgnoreCase("1.txt")) {
                                            totalRecords = 1;
                                        }
                                        objectResponse = new JSONObject(jsonReadText);
                                        if (objectResponse.has("ishop_sticker")) {
                                            Log.v("FILE_TRACK", " FILE::" + tempFile.getAbsolutePath());
                                        }

                                        if (objectResponse.has("ishop_sticker_details")) {
                                            if (!stickerDetailsStart) {
                                                stickerDetailsStart = true;
                                                SDT_start = System.currentTimeMillis();
                                                Log.e("CheckLog", "start" + SDT_start);
                                            }
                                            tableName = getString(R.string.ishopstickerdetails);
                                            ++count;
                                            if (count == 100) {
                                                count = count - 1;
                                            }
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            Log.e("CheckLog", "total" + totalRecords);
                                            DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                                    customer_level,role_code);
                                        } else if (objectResponse.has("ishop_cfa_dispatch_product")) {
                                            tableName = getString(R.string.cfadispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(70);
                                            //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                            databaseCRUD.InsertCFADispatchProductNew1(jsonArrayEmployee);

                                        } else if (objectResponse.has("ishop_sample_dispatch_product")) {
                                            tableName = getString(R.string.cfadispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(71);
//                                            String rolecode = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);
                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseHelperExtended.deleteSampleProductTable();
                                            }
                                            databaseCRUD.InsertSampleFocDispatchProduct(jsonArrayEmployee);

                                        } else if (objectResponse.has("customer_details")) {
                                            tableName = getString(R.string.customerdetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("customer_details");
                                            databaseCRUD.insertCustomerDetails(jsonArrayEmployee, item);
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(72);
                                            dataBaseHelper.updateLoginDetails(jsonArrayEmployee, this);
                                        } else if (objectResponse.has("employee_details")) {
                                            tableName = getString(R.string.customerdetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("employee_details");
                                            databaseCRUD.insertEmployeeDetails(jsonArrayEmployee, item);
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(73);
                                        } else if (objectResponse.has("ishop_sticker")) {
                                            tableName = getString(R.string.ishopsticker);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(74);

                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                            } else if (customer_level.equalsIgnoreCase("L2")) {
                                                databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                            } else {
                                                databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                            }
                                        } else if (objectResponse.has("ishop_toller_dispatch")) {
                                            tableName = getString(R.string.tollerdispatch);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(74);
                                            DatabaseCRUD.InsertTollerDispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_toller_dispatch_product")) {
                                            tableName = getString(R.string.tollerdispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(75);
                                            databaseCRUD.InsertTollerDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_distributor_dispatch_product")) {
                                            tableName = getString(R.string.distributordispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(75);
                                            databaseCRUD.InsertDistributorDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("product_sku_country")) {
                                            tableName = getString(R.string.productskucountry);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_sku_country");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(75);
                                            databaseCRUD.insertProductSkuCountry(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_distributor_return_product")) {
                                            tableName = getString(R.string.distributorreturnproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(76);
                                            databaseCRUD.InsertDistributorReturnProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_distributor_received_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(76);
                                            databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_dispatch_product")) {
                                            tableName = getString(R.string.retailerdispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(77);
                                            databaseCRUD.InsertRetailerDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_received_product")) {
                                            tableName = getString(R.string.retailerreceivedproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(78);
                                            databaseCRUD.InsertRetailerReceivedProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("product_type_name_country")) {
                                            tableName = getString(R.string.producttypenamecountry);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_type_name_country");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(79);
                                            databaseCRUD.insertProductTypeNameCountry(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Scheme_Master")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Scheme_Master");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(79);
                                            databaseCRUD.InsertSchemeMaster(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_cfa_dispatch")) {
                                            tableName = getString(R.string.cfadispatch);
                                            publishProgress(80);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(80);
                                            databaseCRUD.InsertCFADispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_sample_dispatch")) {
                                            tableName = getString(R.string.cfadispatch);
                                            publishProgress(81);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(82);
                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseHelperExtended.deleteSampleMainTable();
                                            }
                                            databaseCRUD.InsertSampleFocDispatchMain(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("cpm_customer_product_stock")) {
                                            tableName = getString(R.string.customerproductstock);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(83);
                                            databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                            databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                            tableName = getString(R.string.customerproductstock);
                                            publishProgress(83);
                                            JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                            databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                                        } else if (objectResponse.has("ishop_distributor_return_request_product")) {
                                            tableName = getString(R.string.distributorreturnrequestproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            if (customer_level.equalsIgnoreCase("L4")) {
                                                databaseCRUD.InsertDistributorReturnRequestProductNew(jsonArrayEmployee);
                                            } else {
                                                databaseCRUD.InsertDistributorReturnRequestProductNewForDist(jsonArrayEmployee);
                                            }
                                        } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                            tableName = getString(R.string.distributordispatch);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("sales_rep_initiated_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.insertSalesRepInitiatedProduct(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_retailer_received")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReceivedNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Political_Details")) {
                                            tableName = getString(R.string.politicaldetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertPoliticalDetails(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Political_Details_Emp")) {
                                            tableName = getString(R.string.politicaldetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details_Emp");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertPoliticalDetailsEmp(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("extra_sticker_detail")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_return")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReturnNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_retailer_return_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReturnProductNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("sales_rep_initiated_product_current_limit")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product_current_limit");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            if (jsonArrayEmployee.length() > 0) {
                                                databaseCRUD.insertSalesReturnCurrentLimit(jsonArrayEmployee);
                                            }
                                        } else if (objectResponse.has("ishop_pallet_details")) {
                                            JSONArray jsonArrayPallet = objectResponse.getJSONArray("ishop_pallet_details");
                                            totalRecords = totalRecords + jsonArrayPallet.length();
                                            if (jsonArrayPallet.length() > 0) {
                                                databaseCRUD.insertPalletDetails(jsonArrayPallet, dataBaseHelper.getLoginId(),customer_level,role_code);
                                            }

                                        } else if (objectResponse.has("ishop_extra_pallet_detail")) {
                                            JSONArray palletExtraStickerDetail = objectResponse.getJSONArray("ishop_extra_pallet_detail");
                                            totalRecords = totalRecords + palletExtraStickerDetail.length();
                                            databaseCRUD.InsertPalletExtraStickerDetail(palletExtraStickerDetail);
                                        } else if (objectResponse.has("bf_scm_cpm_integration_data")) {
                                            JSONArray bfScmList = objectResponse.getJSONArray("bf_scm_cpm_integration_data");
                                            totalRecords = totalRecords + bfScmList.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.insertScmData(bfScmList);
                                        } else if (objectResponse.has("ishop_cfa_return_product")) {
                                            JSONArray cfaReturnProductArray = objectResponse.getJSONArray("ishop_cfa_return_product");
                                            totalRecords = totalRecords + cfaReturnProductArray.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.InsertCFAReturnProductBulk(cfaReturnProductArray);
                                        } else if (objectResponse.has("ishop_cfa_return")) {
                                            JSONArray cfaReturnArray = objectResponse.getJSONArray("ishop_cfa_return");
                                            totalRecords = totalRecords + cfaReturnArray.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.InsertCFAReturnBulk(cfaReturnArray);
                                        } else if (objectResponse.has("ishop_distributor_return_request")) {
                                            JSONArray distReturnRequestArray = objectResponse.getJSONArray("ishop_distributor_return_request");
                                            totalRecords = totalRecords + distReturnRequestArray.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.InsertDistributorReturnRequestBulk(distReturnRequestArray);
                                        }

                                    }
                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }
                            }
                        }
                    }


                    if (!error_code.trim().isEmpty()) {
                        updateActivity();
                        return;
                    }

                    dataBaseHelper.deleteSaveOfflineLogTable();
                    databaseCRUD.deleteUnreceivedValidData();
                    databaseCRUD.deleteRejectedOrder();
                    dataBaseHelper.deleteDamageData();
                    databaseCRUD.deleteDeviceTokenTable();
                    databaseHelperExtended.deleteRejectedData();
                    dataBaseHelper.deleteCfaDispatchIDNotInProductTable();
                    databaseHelperExtended.deleteCfaDispatchIDNotInMainTable();
                    databaseHelperExtended.deleteTransactionErrorLog();
                    insertDelayedTransaction();
//                    Content.setPreferenceValue(this, Const.RECEIVE_BY_CONFIRM, "");

//                    String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                    if (customer_level.equalsIgnoreCase("L3")) {
                        databaseHelperExtended.deleteDistributorReturnRequestData(userID);
                    }

                    long SDT_End = System.currentTimeMillis();
                    try {
                        long difference = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        Log.v("SYNCTRACK", "SDT_ TIME::" + difference);
                        objSyncData.put("SDT", "" + difference);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    long ExtractProcess_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(ExtractProcess_start, ExtractProcess_end);
                    Log.v("SYNCTRACK", "SYPR_ TIME::" + difference);

                    try {
                        long differenceStickerTable = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        long totalRemaining = difference - differenceStickerTable;
                        objSyncData.put("SYPR", totalRemaining);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

//                    stopTimer();

                    if (isPointCalculationSync) {
                        LogHelper.printLog("TAG_SYNC_DATA", "CALL POINT CALC Webservice");
                        callSchemeAPIPoint(syncFileName, syncLogID, "P");
                    } else {
                        callGetUserCurrentPointsAPI(true);
                    }
                }

            } else {
//                stopTimer();
                exceptionDetails = "Download File do not exist.";
                error_code = "108";

                fireError();
            }
        } catch (JSONException e) {
            e.printStackTrace();
//            stopTimer();
            exceptionDetails = AppUtil.getStackTrace(e);
            error_code = "108";

            fireError();
        }
    }


    /**
     * Broadcast to Update Progress Bar
     *
     * @param percent
     */
    private void publishProgress(int percent) {
        if (mBinder.isBinderAlive()) {

            sendBroadCastDetails(444, "Progress@@"+percent, percent);
            
            Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
            intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
            intent.putExtra("FLAG", SyncFlag.FLAG_PROGRESS_UPDATE_TABLES);
            intent.putExtra("errorCode", "");
            intent.putExtra("errorMsg", "");
            intent.putExtra("percent", percent);
            intent.putExtra("table", tableName);
            intent.putExtra("syncLogID", syncLogID);
            sendBroadcast(intent);
        }
    }

    /**
     * Method to Insert the Main Table CFA Dispatch when user has Scanned Valid Code
     * And After that If he does WareHouse Transfer , then on Click for Dispatch
     * and Stock Transfer the Stickers shows as Valid as The main table table entry gets Deleted after Sync
     */
    private void insertDelayedTransaction() {
        try {
            Gson gson = new Gson();
            AppUtil.wareHouseDetailsInfo = gson.fromJson(CFA_DISPATCH, IshopCFADispatch.class);
            if (AppUtil.wareHouseDetailsInfo != null) {
                int latestCfaDipatchID = dataBaseHelper.getProductIdMaxId("cfa_dispatch_id", "bf_ishop_cfa_dispatch");
                AppUtil.wareHouseDetailsInfo.setCFADispatchId(String.valueOf(latestCfaDipatchID));
                databaseCRUD.InsertCFADispatch(AppUtil.wareHouseDetailsInfo, 0);
            }

            //For Stock Transfer
            gson = new Gson();
            AppUtil.wareHouseDetailsInfoStockTransfer = gson.fromJson(CFA_STOCK_TRANSFER, IshopCFADispatch.class);
            if (AppUtil.wareHouseDetailsInfoStockTransfer != null) {
                int latestCfaDipatchID = dataBaseHelper.getProductIdMaxId("cfa_dispatch_id", "bf_ishop_cfa_dispatch");
                AppUtil.wareHouseDetailsInfoStockTransfer.setCFADispatchId(String.valueOf(latestCfaDipatchID));
                try {
                    String data = gson.toJson(AppUtil.wareHouseDetailsInfoStockTransfer);
                    //BD
//                    Content.setPreferenceValue(this, Const.CFA_STOCK_TRANSFER, data);
                } catch (Exception e) {
                    e.printStackTrace();
                }

                databaseCRUD.InsertCFADispatch(AppUtil.wareHouseDetailsInfoStockTransfer, 0);
            }


            //Change By Chandan as there was Duplicate Record entry For Dist Dispatch
            //When User First Login and Scans a Valid code and do not confirm the Transaction
            //and then user goes back and sync. After Sync when we edit the transaction and confirm it
            //there was duplicate entry for the same
            try {
                gson = new Gson();
                AppUtil.retailerDetailsInfo = gson.fromJson(DIST_DISPATCH_MODEL, IshopDistributorDispatch.class);
                if (AppUtil.retailerDetailsInfo != null) {
                    int new_dispatch_id = dataBaseHelper.getProductIdMaxId("distributor_dispatch_id", "bf_ishop_distributor_dispatch");
                    AppUtil.retailerDetailsInfo.setDistributorDispatchId(String.valueOf(new_dispatch_id));

                    //Updating Dispatch ID
                    String details = gson.toJson(AppUtil.retailerDetailsInfo, IshopDistributorDispatch.class);
                    //BD
//                    Content.setPreferenceValue(SynchronizationService.this, Const.DIST_DISPATCH_MODEL, details);
                    databaseCRUD.InsertDistributorDispatch(AppUtil.retailerDetailsInfo, 0);
                }
            } catch (JsonSyntaxException e) {
                e.printStackTrace();
            }

            try {
                gson = new Gson();
                AppUtil.retailerDetailsInfo = gson.fromJson(DIST_DISPATCH_MODEL_BASIC_SCAN, IshopDistributorDispatch.class);
                if (AppUtil.retailerDetailsInfo != null) {
                    if (DIST_DISPATCH_MODEL_BASIC_SCAN_IDS != null && !DIST_DISPATCH_MODEL_BASIC_SCAN_IDS.isEmpty()) {
                        JSONArray arrayList = new JSONArray(DIST_DISPATCH_MODEL_BASIC_SCAN_IDS);
                        if (arrayList.length() > 0) {
                            for (int i = 0; i < arrayList.length(); i++) {
                                JSONObject objResponse = arrayList.getJSONObject(i);
                                int dispatchId = objResponse.getInt("dispatchId");
                                databaseCRUD.InsertDistributorDispatchDelayed(AppUtil.retailerDetailsInfo, 0, dispatchId);
                            }

                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }


        } catch (JsonSyntaxException e) {
            e.printStackTrace();
        }
    }


//    public void stopTimer() {
//        if (mTimer1 != null) {
//            mMin = 0;
//            mMax = 0;
//            mTimer1.cancel();
//            mTimer1.purge();
//        }
//    }
//
//    protected void startTimer() {
//        mTimer1 = new Timer();
//        //TODO
//        TimerTask mTt1 = new TimerTask() {
//            public void run() {
//                mTimerHandler.post(() -> {
//                    //TODO
//                    if (mMin < mMax) {
//                        mMin++;
//                    }
//                    updateNotificationProgress(mMin);
//                });
//            }
//        };
//
//        mTimer1.schedule(mTt1, 1, 5000);
//    }
//
//    protected void increaseTimmer(int min, int max) {
//        stopTimer();
//        mMin = min;
//        mMax = max;
//        startTimer();
//    }


    /**
     * Get User Points
     */
    private void callGetUserCurrentPointsAPI(boolean exit) {

        RestClient restClient = new RestClient(userID,token);

        JSONObject objData = Authentication.getInstance(this).getUserPoints(countryID, userID, dateFolder);
        JSONObject requestParam = Authentication.getInstance(this).getRequestParam(Authentication.getInstance(this).getAuth(countryID,userID,encriptPassword,appVersion,appVersionCode), objData);

        LogHelper.printLog("TAG_SYNC_DATA_POINT", "POINTS REQUEST::" + requestParam);

        Call<JsonObject> call = restClient.get().getUserPoints(countryID, userID, dateFolder, requestParam);
        call.enqueue(new Callback<JsonObject>() {
            @Override
            public void onResponse(Call<JsonObject> call, Response<JsonObject> response) {
                try {
                    LogHelper.printLog("TAG_SYNC_DATA_POINT", "POINTS RESPONSE::" + requestParam);
                    if (response.body() != null) {
                        JSONObject object = new JSONObject(response.body().toString());
                        LogHelper.printLog("TAG_SYNC_DATA", "POINTS::" + object);
                        if (object.getBoolean("status")) {
                            String current_points = object.optString("Total_Points");

                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Const.CURRENT_POINTS, current_points);
                        }
                    }
                    if (exit) updateNotificationProgress(400);
                } catch (JSONException e) {
                    e.printStackTrace();
                } catch (NullPointerException e) {
                    e.printStackTrace();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            @Override
            public void onFailure(Call<JsonObject> call, Throwable t) {
                if (exit) updateNotificationProgress(400);
            }
        });
    }

    /**
     * Save Data to Database
     * Only For Transaction
     */
    private void saveDistributorTransactionData(String downloadFileName) {
        try {

            long ExtractProcess_start = System.currentTimeMillis();
            int totalRecords = 0;
            long SDT_start = System.currentTimeMillis();
            String jsonString;
            File f = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            LogHelper.printLog("TAG_FILE", "FILE::: " + DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            if (f.exists()) {
                LogHelper.printLog("TAG_FILE", "FILE::: " + f.getAbsolutePath());
                jsonString = DownloadFileFromURL.readTextFile(f.getPath());

                if (!jsonString.equalsIgnoreCase("")) {
                    JSONObject objectResponse = new JSONObject(jsonString);
                    if (objectResponse.getBoolean("status")) {

                        if (objectResponse.has("ishop_distributor_received")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received");
                            databaseCRUD.InsertDistributorReceivedNew(jsonArrayEmployee);
                        }

                        if (objectResponse.has("ishop_customer_scaned_in_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_in_sticker");
                            databaseCRUD.InsertRETAILERSCANNEDINNew(jsonArrayEmployee);
                        }

                        //Used in Both Retailer and Distributor
                        if (objectResponse.has("ishop_customer_scaned_out_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_out_sticker");
                            databaseCRUD.insertRetailerScannedOutSticker(jsonArrayEmployee);
                        }

                        if (objectResponse.has("Last_Sync_Date_Time")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Last_Sync_Date_Time");
                            databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 1);
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Content.LAST_SYNC_DATE, jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                        }

                        if (objectResponse.has("isKYCDone")) {
                            String isKYCDone = objectResponse.getString("isKYCDone");
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
                        }

                    }

                    publishProgress(60);

                    File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
                    boolean stickerDetailsStart = false;
                    if (dir.exists() && dir.isDirectory()) {
                        String[] dirs = dir.list();
                        for (String items : dirs) {
                            Log.v("FILE TRACK", " DIRECTORY::" + items);
                            File file = new File(dir.getAbsolutePath() + "/" + items);
                            if (file.isDirectory()) {
                                String[] subDirs = file.list();
                                int count = 92;
                                for (String item : subDirs) {
                                    if (totalProgress < 350) {
                                        totalProgress = totalProgress + 1;
                                    }

                                    Log.v("FILE TRACK", " FILE::" + items);
                                    File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);

                                    if (tempFile.exists()) {
                                        jsonString = DownloadFileFromURL.readTextFile(tempFile.getPath());
                                    }
                                    if (item.equalsIgnoreCase("1.txt")) {
                                        totalRecords = 1;
                                    }
                                    objectResponse = new JSONObject(jsonString);

                                    if (objectResponse.has("ishop_sticker_details")) {
                                        if (!stickerDetailsStart) {
                                            stickerDetailsStart = true;
                                            SDT_start = System.currentTimeMillis();
                                            Log.e("CheckLog", "start" + SDT_start);
                                        }
                                        tableName = getString(R.string.ishopstickerdetails);
                                        ++count;
                                        if (count == 100) {
                                            count = count - 1;
                                        }
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        Log.e("CheckLog", "total" + totalRecords);
//                                        publishProgress(count);
                                        DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                                customer_level,role_code);
                                    } else if (objectResponse.has("ishop_cfa_dispatch_product")) {
                                        tableName = getString(R.string.cfadispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(61);
                                        //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                        databaseCRUD.InsertCFADispatchProductNew1(jsonArrayEmployee);

                                    } else if (objectResponse.has("ishop_sticker")) {
                                        tableName = getString(R.string.ishopsticker);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(62);

                                        if (role_code.equalsIgnoreCase("FO")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else if (customer_level.equalsIgnoreCase("L2")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else {
                                            databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                        }
                                    } else if (objectResponse.has("ishop_cfa_dispatch")) {
                                        tableName = getString(R.string.cfadispatch);
                                        publishProgress(63);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(64);
                                        databaseCRUD.InsertCFADispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_distributor_received_product")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(65);
                                        databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("cpm_customer_product_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(66);
                                        databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                        databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        publishProgress(67);
                                        JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                        databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                                    } else if (objectResponse.has("ishop_distributor_return_request_product")) {
                                        tableName = getString(R.string.distributorreturnrequestproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
//                                        String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                                        if (customer_level.equalsIgnoreCase("L4")) {
                                            databaseCRUD.InsertDistributorReturnRequestProductNew(jsonArrayEmployee);
                                        } else {
                                            databaseCRUD.InsertDistributorReturnRequestProductNewForDist(jsonArrayEmployee);
                                        }
                                    } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                        tableName = getString(R.string.distributordispatch);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(68);
                                        //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_distributor_dispatch_product")) {
                                        tableName = getString(R.string.distributordispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(69);
                                        databaseCRUD.InsertDistributorDispatchProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("extra_sticker_detail")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                                    } else if (objectResponse.has("ishop_pallet_details")) {
                                        JSONArray jsonArrayPallet = objectResponse.getJSONArray("ishop_pallet_details");
                                        totalRecords = totalRecords + jsonArrayPallet.length();
                                        if (jsonArrayPallet != null && jsonArrayPallet.length() > 0) {
                                            databaseCRUD.insertPalletDetails(jsonArrayPallet, dataBaseHelper.getLoginId(),customer_level,role_code);
                                        }
                                    } else if (objectResponse.has("ishop_extra_pallet_detail")) {
                                        JSONArray palletExtraStickerDetail = objectResponse.getJSONArray("ishop_extra_pallet_detail");
                                        totalRecords = totalRecords + palletExtraStickerDetail.length();
                                        databaseCRUD.InsertPalletExtraStickerDetail(palletExtraStickerDetail);
                                    } else if (objectResponse.has("ishop_distributor_received_product")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(70);
                                        databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("sales_rep_initiated_product")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.insertSalesRepInitiatedProduct(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("sales_rep_initiated_product_current_limit")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product_current_limit");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        if (jsonArrayEmployee.length() > 0) {
                                            databaseCRUD.insertSalesReturnCurrentLimit(jsonArrayEmployee);
                                        }
                                    } else if (objectResponse.has("ishop_cfa_return_product")) {
                                        JSONArray cfaReturnProductArray = objectResponse.getJSONArray("ishop_cfa_return_product");
                                        totalRecords = totalRecords + cfaReturnProductArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertCFAReturnProductBulk(cfaReturnProductArray);
                                    } else if (objectResponse.has("ishop_cfa_return")) {
                                        JSONArray cfaReturnArray = objectResponse.getJSONArray("ishop_cfa_return");
                                        totalRecords = totalRecords + cfaReturnArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertCFAReturnBulk(cfaReturnArray);
                                    } else if (objectResponse.has("ishop_distributor_return_request")) {
                                        JSONArray distReturnRequestArray = objectResponse.getJSONArray("ishop_distributor_return_request");
                                        totalRecords = totalRecords + distReturnRequestArray.length();
                                        Log.e("totalRecords--", totalRecords + "");
                                        databaseCRUD.InsertDistributorReturnRequestBulk(distReturnRequestArray);
                                    }

                                }
                            }
                        }
                    }


                    if (!error_code.trim().isEmpty()) {
                        updateActivity();
                        return;
                    }

                    dataBaseHelper.deleteSaveOfflineLogTable();
                    databaseCRUD.deleteUnreceivedValidData();
                    databaseCRUD.deleteRejectedOrder();
                    dataBaseHelper.deleteDamageData();
                    databaseCRUD.deleteDeviceTokenTable();
                    databaseHelperExtended.deleteRejectedData();
                    dataBaseHelper.deleteCfaDispatchIDNotInProductTable();
                    databaseHelperExtended.deleteCfaDispatchIDNotInMainTable();
                    databaseHelperExtended.deleteTransactionErrorLog();
                    insertDelayedTransaction();
//                    Content.setPreferenceValue(this, Const.RECEIVE_BY_CONFIRM, "");

                    DatabaseHelperExtended databaseHelperExtended = new DatabaseHelperExtended(this);
                    databaseHelperExtended.updateRetailerReceiveProductSyncFlag();
                    databaseHelperExtended.updateRetailerDispatchProductSyncFlag();

//                    String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                    if (customer_level.equalsIgnoreCase("L3")) {
                        databaseHelperExtended.deleteDistributorReturnRequestData(userID);
                    }

                    long SDT_End = System.currentTimeMillis();
                    try {
                        long difference = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        Log.v("SYNCTRACK", "SDT_ TIME::" + difference);
                        objSyncData.put("SDT", "" + difference);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    long ExtractProcess_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(ExtractProcess_start, ExtractProcess_end);
                    Log.v("SYNCTRACK", "SYPR_ TIME::" + difference);

                    try {
                        long differenceStickerTable = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        long totalRemaining = difference - differenceStickerTable;
                        objSyncData.put("SYPR", totalRemaining);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

//                    stopTimer();

                    //Deleting Discarded Record For All Customers and Employees
                    if (isPointCalculationSync) {
                        LogHelper.printLog("TAG_SYNC_DATA", "CALL POINT CALC Webservice");
                        callSchemeAPIPoint(syncFileName, syncLogID, "P");
                    } else {
                        callGetUserCurrentPointsAPI(true);
                    }


                }


            } else {
                exceptionDetails = "Download File do not exist.";
                error_code = "108";
//                stopTimer();

                fireError();
            }
        } catch (JSONException e) {
            e.printStackTrace();
//            stopTimer();
            exceptionDetails = AppUtil.getStackTrace(e);
            error_code = "108";

            fireError();
        }
    }


    /**
     * Save Data to Database
     * Only For Transaction
     */
    private void saveRetailerTransactionData(String downloadFileName) {
        try {

            long ExtractProcess_start = System.currentTimeMillis();
            int totalRecords = 0;
            long SDT_start = System.currentTimeMillis();
            String jsonString;
            File f = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            LogHelper.printLog("TAG_FILE", "FILE::: " + DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            if (f.exists()) {
                LogHelper.printLog("TAG_FILE", "FILE::: " + f.getAbsolutePath());
                jsonString = DownloadFileFromURL.readTextFile(f.getPath());

                if (!jsonString.equalsIgnoreCase("")) {
                    JSONObject objectResponse = new JSONObject(jsonString);
                    if (objectResponse.getBoolean("status")) {

                        tableName = getString(R.string.retailerdispatch);
                        publishProgress(60);
                        if (objectResponse.has("ishop_retailer_dispatch")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch");
                            databaseCRUD.InsertRetailerDispatchNew(jsonArrayEmployee);
                        }

                        if (objectResponse.has("ishop_customer_scaned_in_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_in_sticker");
                            databaseCRUD.InsertRETAILERSCANNEDINNew(jsonArrayEmployee);
                        }

                        //Used in Both Retailer and Distributor
                        if (objectResponse.has("ishop_customer_scaned_out_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_out_sticker");
                            databaseCRUD.insertRetailerScannedOutSticker(jsonArrayEmployee);
                        }

                        if (objectResponse.has("Last_Sync_Date_Time")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Last_Sync_Date_Time");
                            databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 1);
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Content.LAST_SYNC_DATE, jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                        }

                        if (objectResponse.has("isKYCDone")) {
                            String isKYCDone = objectResponse.getString("isKYCDone");
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
                        }

                    }

                    publishProgress(61);

                    File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
                    boolean stickerDetailsStart = false;
                    if (dir.exists() && dir.isDirectory()) {
                        String[] dirs = dir.list();
                        for (String items : dirs) {
                            Log.v("FILE TRACK", " DIRECTORY::" + items);
                            File file = new File(dir.getAbsolutePath() + "/" + items);
                            if (file.isDirectory()) {
                                String[] subDirs = file.list();
                                int count = 92;
                                for (String item : subDirs) {
                                    if (totalProgress < 350) {
                                        totalProgress = totalProgress + 1;
                                    }

                                    Log.v("FILE TRACK", " FILE::" + items);
                                    File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);

                                    if (tempFile.exists()) {
                                        jsonString = DownloadFileFromURL.readTextFile(tempFile.getPath());
                                    }
                                    if (item.equalsIgnoreCase("1.txt")) {
                                        totalRecords = 1;
                                    }
                                    objectResponse = new JSONObject(jsonString);

                                    if (objectResponse.has("ishop_sticker_details")) {
                                        if (!stickerDetailsStart) {
                                            stickerDetailsStart = true;
                                            SDT_start = System.currentTimeMillis();
                                            Log.e("CheckLog", "start" + SDT_start);
                                        }
                                        tableName = getString(R.string.ishopstickerdetails);
                                        ++count;
                                        if (count == 100) {
                                            count = count - 1;
                                        }
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        Log.e("CheckLog", "total" + totalRecords);
//                                        publishProgress(count);
                                        DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                                customer_level,role_code);
                                    } else if (objectResponse.has("ishop_sticker")) {
                                        tableName = getString(R.string.ishopsticker);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(62);


//                                        String customer_level = Content.getPreferenceValue(SynchronizationService.this, Const.CUSTOMER_LEVEL);
//                                        String role_code = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);

                                        if (role_code.equalsIgnoreCase("FO")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else if (customer_level.equalsIgnoreCase("L2")) {
                                            databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                        } else {
                                            databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                        }
                                    } else if (objectResponse.has("ishop_distributor_dispatch_product")) {
                                        tableName = getString(R.string.distributordispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(63);
                                        databaseCRUD.InsertDistributorDispatchProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                        tableName = getString(R.string.distributordispatch);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(64);
                                        //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                        databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_retailer_received")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertRetailerReceivedNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_retailer_received_product")) {
                                        tableName = getString(R.string.retailerreceivedproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(65);
                                        databaseCRUD.InsertRetailerReceivedProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("ishop_retailer_return")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertRetailerReturnNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_retailer_return_product")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertRetailerReturnProductNew(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("ishop_retailer_dispatch_product")) {
                                        tableName = getString(R.string.retailerdispatchproduct);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(66);
                                        databaseCRUD.InsertRetailerDispatchProductNew(jsonArrayEmployee);
                                    } else if (objectResponse.has("cpm_customer_product_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        publishProgress(67);
                                        databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                        databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                        tableName = getString(R.string.customerproductstock);
                                        publishProgress(68);
                                        JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                        databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                                    } else if (objectResponse.has("extra_sticker_detail")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                                    } else if (objectResponse.has("sales_rep_initiated_product")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        databaseCRUD.insertSalesRepInitiatedProduct(jsonArrayEmployee, item);
                                    } else if (objectResponse.has("sales_rep_initiated_product_current_limit")) {
                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product_current_limit");
                                        totalRecords = totalRecords + jsonArrayEmployee.length();
                                        if (jsonArrayEmployee.length() > 0) {
                                            databaseCRUD.insertSalesReturnCurrentLimit(jsonArrayEmployee);
                                        }
                                    }

                                }
                            }
                        }
                    }


                    if (!error_code.trim().isEmpty()) {
                        updateActivity();
                        return;
                    }

                    dataBaseHelper.deleteSaveOfflineLogTable();
                    databaseCRUD.deleteUnreceivedValidData();
                    databaseCRUD.deleteRejectedOrder();
                    dataBaseHelper.deleteDamageData();
                    databaseCRUD.deleteDeviceTokenTable();
                    databaseHelperExtended.deleteRejectedData();
                    dataBaseHelper.deleteCfaDispatchIDNotInProductTable();
                    databaseHelperExtended.deleteCfaDispatchIDNotInMainTable();
                    databaseHelperExtended.deleteTransactionErrorLog();
                    insertDelayedTransaction();
//                    Content.setPreferenceValue(this, Const.RECEIVE_BY_CONFIRM, "");

                    DatabaseHelperExtended databaseHelperExtended = new DatabaseHelperExtended(this);
//                    databaseHelperExtended.updateRetailerReceiveProductSyncFlag();
//                    databaseHelperExtended.updateRetailerDispatchProductSyncFlag();

//                    String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                    if (customer_level.equalsIgnoreCase("L3")) {
                        databaseHelperExtended.deleteDistributorReturnRequestData(userID);
                    }

                    long SDT_End = System.currentTimeMillis();
                    try {
                        long difference = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        Log.v("SYNCTRACK", "SDT_ TIME::" + difference);
                        objSyncData.put("SDT", "" + difference);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    long ExtractProcess_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(ExtractProcess_start, ExtractProcess_end);
                    Log.v("SYNCTRACK", "SYPR_ TIME::" + difference);

                    try {
                        long differenceStickerTable = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        long totalRemaining = difference - differenceStickerTable;
                        objSyncData.put("SYPR", totalRemaining);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

//                    stopTimer();

                    //Deleting Discarded Record For All Customers and Employees
                    if (isPointCalculationSync) {
                        LogHelper.printLog("TAG_SYNC_DATA", "CALL POINT CALC Webservice");
                        callSchemeAPIPoint(syncFileName, syncLogID, "P");
                    } else {
                        callGetUserCurrentPointsAPI(true);
                    }
                }


            } else {
                exceptionDetails = "Download File do not exist.";
                error_code = "108";
//                stopTimer();

                fireError();

            }
        } catch (JSONException e) {
            e.printStackTrace();
//            stopTimer();
            exceptionDetails = AppUtil.getStackTrace(e);
            error_code = "108";

            fireError();
        }
    }

    private void handleResponseForTransaction(JSONObject objectResponse, long startTime, String syncType) {
        if (isMasterSync && isTransactionSync) {
            Log.e("SYNC_REQUEST", "TRANSACTION RESPONSE DIRECT MASTER::" + objectResponse.toString());
            callSyncAPI(syncFileName, syncLogID, "G");
        } else {
            try {
                Log.e("SYNC_REQUEST", "TRANSACTION RESPONSE ONLY TRANSACTION::" + objectResponse.toString());

                //BD
                String announcement_count = objectResponse.optString("announcement_count");
//                Content.setPreferenceValue(SynchronizationService.this, Const.NOTIFICATION_COUNT, announcement_count);

                if (objectResponse.getBoolean("status")) {
//                    int startProgress;
//                    int endProgress;
//                    if (isLocalTransactionAvailable) {
//                        startProgress = 200;
//                        endProgress = 300;
//                    } else {
//                        startProgress = 100;
//                        endProgress = 250;
//                    }
//
//                    increaseTimmer(startProgress, endProgress);

                    long SYNC_API_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(startTime, SYNC_API_end);
                    Log.v("SYNCTRACK", "SAPI_ TIME::" + difference);
                    objSyncData.put("SAPI", difference);
                    syncLogID = objectResponse.optString("sync_log_id");
                    LogHelper.printLog("SYNC_LOG_ID_SYNC", "SYNC LOG ID::: " + syncLogID);
                    if (!objectResponse.optString("kyc_url").isEmpty()) {
                        //BD
//                        Content.setPreferenceValue(SynchronizationService.this, Const.KYC_URL, objectResponse.optString("kyc_url"));
                    }

                    if (!objectResponse.optString("filename").isEmpty()) {
                        syncFileName = objectResponse.getString("filename");
                    }
                    String fileDownloadUrl = objectResponse.getString("download_url");

                    if (objectResponse.has("user_manual_url")) {
                        userManualLink = objectResponse.getString("user_manual_url");
                        userFAQLink = objectResponse.getString("user_faq_url");
                        is_faq_updated = objectResponse.getString("is_faq_updated");
                        is_manual_updated = objectResponse.getString("is_manual_updated");
                    }
                    FD_start = System.currentTimeMillis();
                    new DownloadFileFromURL(SynchronizationService.this, syncFileName, fileDownload, syncType).execute(fileDownloadUrl);
                } else {
                    String msg_code = objectResponse.optString("msg_code");
                    if (objectResponse.has("isLoginCheck")) {
                        if (objectResponse.getInt("isLoginCheck") == 0) {
                            error_code = "212";
                            exceptionDetails = objectResponse.getString("message");
                            updateActivity();
                        } else {
                            objTermsCondition = new JSONObject();
                            objTermsCondition = objectResponse;
                            if (objectResponse.has("filename")) {
                                syncFileName = objectResponse.getString("filename");
                            }
                            msg_code = objectResponse.optString("msg_code");
                            error_code = msg_code;
                            exceptionDetails = objectResponse.getString("message");

                            if (!msg_code.trim().isEmpty() && msg_code.equalsIgnoreCase(SyncErrorCode.UPDATE_VERSION)) {

                                showMessageForVersionUpdate(msg_code, objectResponse.getString("message"), objectResponse.getString("link"));

                            } else {
                                String terms_condition = objectResponse.optString("terms_condition_url");
                                if (terms_condition != null && !terms_condition.isEmpty()) {
                                    showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 1, objTermsCondition);
                                } else {
                                    showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 2, objTermsCondition);
                                }
                            }

                        }
//                        stopTimer();
                    } else if (msg_code.equalsIgnoreCase("501")
                            || msg_code.equalsIgnoreCase("213")
                            || msg_code.equalsIgnoreCase("503")) {
                        error_code = msg_code;
                        exceptionDetails = objectResponse.getString("message");
                        updateActivity();

//                        stopTimer();
                    } else {
                        objTermsCondition = new JSONObject();
                        objTermsCondition = objectResponse;
                        if (objectResponse.has("filename")) {
                            syncFileName = objectResponse.getString("filename");
                        }
                        msg_code = objectResponse.optString("msg_code");
                        error_code = msg_code;
                        exceptionDetails = objectResponse.getString("message");

                        if (!msg_code.trim().isEmpty() && msg_code.equalsIgnoreCase(SyncErrorCode.UPDATE_VERSION)) {

                            showMessageForVersionUpdate(msg_code, objectResponse.getString("message"), objectResponse.getString("link"));

                        } else {
                            //                        For Terms and Conditions
                            String terms_condition = objectResponse.optString("terms_condition_url");
                            if (terms_condition != null && !terms_condition.isEmpty()) {
                                showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 1, objTermsCondition);
                            } else {
                                showTermsInHomeActivity(terms_condition, objectResponse.getString("message"), 2, objTermsCondition);
                            }
                        }

//                        stopTimer();
                    }

                }
            } catch (JSONException e) {
                e.printStackTrace();
                error_code = String.valueOf(SyncErrorCode.ERROR_105_1);
                exceptionDetails = AppUtil.getStackTrace(e);
                updateActivity();
//                stopTimer();
            }
        }
    }

    /**
     * Updating Lang Code
     *
     * @param lang_code
     */
    private void updateLanguage(String lang_code) {
        ArrayList<LanguageModel> list_lang = AppUtil.getLangList();

        if (list_lang != null && list_lang.size() > 0) {
            for (int i = 0; i < list_lang.size(); i++) {
                if (list_lang.get(i).getLang_name().equalsIgnoreCase(lang_code)) {
                    //BD
//                    Content.setPreferenceValue(this, Const.LANGUAGE_CODE, list_lang.get(i).getLang_code());
                    break;
                }
            }
        }
    }


    /**
     * Save Master Data using JsonObject of Gson Library
     *
     * @param obj
     */
    private void saveTempMasterData(JsonObject obj, String downloadFileName, long SDT_start) throws JSONException {
        int totalRecords = 0;
        JsonElement jsonElement = obj.get("status");
        Log.v("TAG_JSON", jsonElement.toString());
        if (obj.get("status").getAsBoolean()) {

            if (obj.has("master_new_customer")) {
                JsonArray jsonArrayEmployee = obj.get("master_new_customer").getAsJsonArray();
                Type listType = new TypeToken<ArrayList<CreateNewCustomer>>() {
                }.getType();
                List<CreateNewCustomer> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListCustomer.clear();
                DatabaseCRUD.arrayListCustomer.addAll(arrayListTollerDispatchProduct);
            }
            tableName = getString(R.string.retailerdispatch);
            publishProgress(5);
            if (obj.has("ishop_retailer_dispatch")) {
                JsonArray arr = obj.get("ishop_retailer_dispatch").getAsJsonArray();
                JSONArray jsonArrayEmployee = null;
                try {
                    jsonArrayEmployee = new JSONArray(arr.toString());
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                databaseCRUD.InsertRetailerDispatchNew(jsonArrayEmployee);
            }

            tableName = getString(R.string.distributorreturn);
            publishProgress(36);
            if (obj.has("ishop_distributor_return")) {
                JsonArray arr = obj.get("ishop_distributor_return").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertDistributorReturnNew(jsonArrayEmployee);
            }

            tableName = getString(R.string.distributorreturnrequest);
            publishProgress(38);

            if (obj.has("ishop_distributor_return_request")) {
                JsonArray arr = obj.get("ishop_distributor_return_request").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertDistributorReturnRequestNew(jsonArrayEmployee);
            }

            tableName = getString(R.string.cfareturnrequest);
            publishProgress(42);
            if (obj.has("ishop_cfa_return")) {
                JsonArray arr = obj.get("ishop_cfa_return").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertCFAReturnNew(jsonArrayEmployee);
            }

            tableName = getString(R.string.cfareturnrequestproduct);
            publishProgress(45);
            if (obj.has("ishop_cfa_return_product")) {
                JsonArray arr = obj.get("ishop_cfa_return_product").getAsJsonArray();
                databaseCRUD.InsertCFAReturnProductGson(arr);
            }

            tableName = getString(R.string.menuaccess);
            publishProgress(52);
            if (obj.has("Menu_Access")) {
                JsonArray arr = obj.get("Menu_Access").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<MenuAccess>>() {
                }.getType();
                List<MenuAccess> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListMenuAccess.clear();
                DatabaseCRUD.arrayListMenuAccess.addAll(arrayListTollerDispatchProduct);
            }

            tableName = getString(R.string.politicallevel);
            publishProgress(54);
            if (obj.has("Political_Level")) {
                JsonArray arr = obj.get("Political_Level").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<PoliticalLevel>>() {
                }.getType();
                List<PoliticalLevel> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListPoliticalLevel.clear();
                DatabaseCRUD.arrayListPoliticalLevel.addAll(arrayListEmployee);
            }

            tableName = getString(R.string.distributorreceived);
            publishProgress(59);
            if (obj.has("ishop_distributor_received")) {
                JsonArray arr = obj.get("ishop_distributor_received").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertDistributorReceivedNew(jsonArrayEmployee);
            }
            tableName = getString(R.string.distributorreceivedproduct);
            publishProgress(60);
            if (obj.has("ishop_distributor_received_product")) {
                JsonArray arr = obj.get("ishop_distributor_received_product").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
//                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
            }
            tableName = getString(R.string.retailerreceived);
            publishProgress(62);

            if (obj.has("ishop_customer_scaned_in_sticker")) {
                JsonArray arr = obj.get("ishop_customer_scaned_in_sticker").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<ScannedPoints>>() {
                }.getType();
                List<ScannedPoints> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListScannedPoints.clear();
                DatabaseCRUD.arrayListScannedPoints.addAll(arrayListEmployee);
            }


            //Used in Both Retailer and Distributor
            if (obj.has("ishop_customer_scaned_out_sticker")) {
                JsonArray arr = obj.get("ishop_customer_scaned_out_sticker").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.insertRetailerScannedOutSticker(jsonArrayEmployee);
            }

            tableName = "Sales Representative";
            publishProgress(63);
            //CtoCMapping
            if (obj.has("ctocmapping")) {
                JsonArray arr = obj.get("ctocmapping").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<CtoCMapping>>() {
                }.getType();
                List<CtoCMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListCtoCMapping.clear();
                DatabaseCRUD.arrayListCtoCMapping.addAll(arrayListEmployee);
            }

            if (obj.has("ctoemapping")) {
                JsonArray arr = obj.get("ctoemapping").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<CtoEMapping>>() {
                }.getType();
                List<CtoEMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListCtoEMapping.clear();
                DatabaseCRUD.arrayListCtoEMapping.addAll(arrayListEmployee);
            }

            if (obj.has("user_configuration_mst")) {
                JsonArray arr = obj.get("user_configuration_mst").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<UserConfigurationMst>>() {
                }.getType();
                List<UserConfigurationMst> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                Log.e("userConfigList", "" + arrayListEmployee);
                Log.e("userConfigList", "" + jsonArrayEmployee);
                DatabaseCRUD.arrayListUserConfigurationMst.clear();
                DatabaseCRUD.arrayListUserConfigurationMst.addAll(arrayListEmployee);
            }
            //
            if (obj.has("Last_Sync_Date_Time")) {
                JsonArray arr = obj.get("Last_Sync_Date_Time").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 2);
                //BD
//                Content.setPreferenceValue(SynchronizationService.this, Content.LAST_SYNC_DATE, jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
            }

//                        updateNotificationProgress(308);
            //table CustomerType_Details
            if (obj.has("CustomerType_Details")) {
                JsonArray arr = obj.get("CustomerType_Details").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                Type listType = new TypeToken<ArrayList<CustomerTypeDetails>>() {
                }.getType();
                List<CustomerTypeDetails> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                DatabaseCRUD.arrayListCustomerType_Details.clear();
                DatabaseCRUD.arrayListCustomerType_Details.addAll(arrayListEmployee);
            }
            tableName = getString(R.string.employeeretailer);
            publishProgress(67);
            if (obj.has("etormapping")) {
                JsonArray arr = obj.get("etormapping").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertETORMAPPINGNew(jsonArrayEmployee);
            }
            if (obj.has("rtormapping")) {
                JsonArray arr = obj.get("rtormapping").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertRtoRMappingNew(jsonArrayEmployee);
            }
            if (obj.has("dtormapping")) {
                JsonArray arr = obj.get("dtormapping").getAsJsonArray();
                JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
                databaseCRUD.InsertDtoRMappingNew(jsonArrayEmployee);
            }

            databaseCRUD.DumpEmployeeDetails();

            if (obj.has("isKYCDone")) {
                Log.d("KYCVAL==", obj.get("isKYCDone").getAsString());
                String isKYCDone = obj.get("isKYCDone").getAsString();
                //BD
//                Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
            }
        }
        publishProgress(69);

        tableName = "VIDEO Detail";
        if (obj.has("User_Help_Video")) {
            JsonArray arr = obj.get("User_Help_Video").getAsJsonArray();
            JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
            databaseCRUD.InsertHelpVideoData(jsonArrayEmployee, dataBaseHelper.getLoginId(),countryID);
        }
        tableName = DataBaseHelper.TABLE_MASTER_REASON;
        if (obj.has("master_reason")) {
            JsonArray arr = obj.get("master_reason").getAsJsonArray();
            JSONArray jsonArrayEmployee = new JSONArray(arr.toString());
            databaseCRUD.insertMasterReason(jsonArrayEmployee);
        }
        File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
        boolean stickerDetailsStart = false;
        if (dir.exists() && dir.isDirectory()) {
            String[] dirs = dir.list();
            for (String items : dirs) {
                Log.v("FILE TRACK", " DIRECTORY::" + items);
                File file = new File(dir.getAbsolutePath() + "/" + items);
                if (file.isDirectory()) {
                    String[] subDirs = file.list();
                    int count = 92;
                    try {
                        for (String item : subDirs) {
                            if (totalProgress < 350) {
                                totalProgress = totalProgress + 1;
                            }

                            Log.v("FILE TRACK", " FILE::" + items);
                            File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);
                            String jsonString = "";
                            if (tempFile.exists()) {
                                jsonString = DownloadFileFromURL.readTextFile(tempFile.getPath());
                            }
                            if (item.equalsIgnoreCase("1.txt")) {
                                totalRecords = 1;
                            }
                            JSONObject objectResponse = new JSONObject(jsonString);

                            if (objectResponse.has("ishop_sticker_details")) {
                                if (!stickerDetailsStart) {
                                    stickerDetailsStart = true;
                                    SDT_start = System.currentTimeMillis();
                                    Log.e("CheckLog", "start" + SDT_start);
                                }
                                tableName = getString(R.string.ishopstickerdetails);
                                ++count;
                                if (count == 100) {
                                    count = count - 1;
                                }
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                Log.e("CheckLog", "total" + totalRecords);
                                publishProgress(count);
                                DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                        customer_level,role_code);
                            } else if (objectResponse.has("ishop_cfa_dispatch_product")) {
                                tableName = getString(R.string.cfadispatchproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(79);
                                //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                databaseCRUD.InsertCFADispatchProductNew1(jsonArrayEmployee);

                            } else if (objectResponse.has("ishop_sample_dispatch_product")) {
                                tableName = getString(R.string.cfadispatchproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(79);
//                                String rolecode = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);
                                if (role_code.equalsIgnoreCase("FO")) {
                                    databaseHelperExtended.deleteSampleProductTable();
                                }
                                databaseCRUD.InsertSampleFocDispatchProduct(jsonArrayEmployee);

                            } else if (objectResponse.has("customer_details")) {
                                tableName = getString(R.string.customerdetails);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("customer_details");
                                databaseCRUD.insertCustomerDetails(jsonArrayEmployee, item);
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(79);
                                dataBaseHelper.updateLoginDetails(jsonArrayEmployee, this);
                            } else if (objectResponse.has("employee_details")) {
                                tableName = getString(R.string.customerdetails);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("employee_details");
                                databaseCRUD.insertEmployeeDetails(jsonArrayEmployee, item);
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(80);
                            } else if (objectResponse.has("ishop_sticker")) {
                                tableName = getString(R.string.ishopsticker);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(86);


//                                String customer_level = Content.getPreferenceValue(SynchronizationService.this, Const.CUSTOMER_LEVEL);
//                                String role_code = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);

                                if (role_code.equalsIgnoreCase("FO")) {
                                    databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                } else if (customer_level.equalsIgnoreCase("L2")) {
                                    databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                } else {
                                    databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                }
                            } else if (objectResponse.has("ishop_toller_dispatch")) {
                                tableName = getString(R.string.tollerdispatch);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(86);
                                DatabaseCRUD.InsertTollerDispatchNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_toller_dispatch_product")) {
                                tableName = getString(R.string.tollerdispatchproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(86);
                                databaseCRUD.InsertTollerDispatchProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("ishop_distributor_dispatch_product")) {
                                tableName = getString(R.string.distributordispatchproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(82);
                                databaseCRUD.InsertDistributorDispatchProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("product_sku_country")) {
                                tableName = getString(R.string.productskucountry);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_sku_country");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(82);
                                databaseCRUD.insertProductSkuCountry(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_distributor_return_product")) {
                                tableName = getString(R.string.distributorreturnproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
                                databaseCRUD.InsertDistributorReturnProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("ishop_distributor_received_product")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(83);
                                databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("ishop_retailer_dispatch_product")) {
                                tableName = getString(R.string.retailerdispatchproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(83);
                                databaseCRUD.InsertRetailerDispatchProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("ishop_retailer_received_product")) {
                                tableName = getString(R.string.retailerreceivedproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
                                databaseCRUD.InsertRetailerReceivedProductNew(jsonArrayEmployee);
                            } else if (objectResponse.has("product_type_name_country")) {
                                tableName = getString(R.string.producttypenamecountry);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_type_name_country");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
                                databaseCRUD.insertProductTypeNameCountry(jsonArrayEmployee, item);
                            } else if (objectResponse.has("Scheme_Master")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Scheme_Master");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
                                databaseCRUD.InsertSchemeMaster(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_cfa_dispatch")) {
                                tableName = getString(R.string.cfadispatch);
                                publishProgress(78);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
                                databaseCRUD.InsertCFADispatchNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_sample_dispatch")) {
                                tableName = getString(R.string.cfadispatch);
                                publishProgress(78);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(84);
//                                String rolecode = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);
                                if (role_code.equalsIgnoreCase("FO")) {
                                    databaseHelperExtended.deleteSampleMainTable();
                                }
                                databaseCRUD.InsertSampleFocDispatchMain(jsonArrayEmployee, item);
                            } else if (objectResponse.has("cpm_customer_product_stock")) {
                                tableName = getString(R.string.customerproductstock);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(72);
                                databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                            } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                tableName = getString(R.string.customerproductstock);
                                publishProgress(72);
                                JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                            } else if (objectResponse.has("ishop_distributor_return_request_product")) {
                                tableName = getString(R.string.distributorreturnrequestproduct);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
//                                String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                                if (customer_level.equalsIgnoreCase("L4")) {
                                    databaseCRUD.InsertDistributorReturnRequestProductNew(jsonArrayEmployee);
                                } else {
                                    databaseCRUD.InsertDistributorReturnRequestProductNewForDist(jsonArrayEmployee);
                                }
                            } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                tableName = getString(R.string.distributordispatch);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                publishProgress(80);
                                //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("sales_rep_initiated_product")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.insertSalesRepInitiatedProduct(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_retailer_received")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertRetailerReceivedNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("Political_Details")) {
                                tableName = getString(R.string.politicaldetails);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertPoliticalDetails(jsonArrayEmployee, item);
                            } else if (objectResponse.has("Political_Details_Emp")) {
                                tableName = getString(R.string.politicaldetails);
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details_Emp");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertPoliticalDetailsEmp(jsonArrayEmployee, item);
                            } else if (objectResponse.has("extra_sticker_detail")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                            } else if (objectResponse.has("ishop_retailer_return")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertRetailerReturnNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("ishop_retailer_return_product")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return_product");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                databaseCRUD.InsertRetailerReturnProductNew(jsonArrayEmployee, item);
                            } else if (objectResponse.has("sales_rep_initiated_product_current_limit")) {
                                JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product_current_limit");
                                totalRecords = totalRecords + jsonArrayEmployee.length();
                                if (jsonArrayEmployee != null && jsonArrayEmployee.length() > 0) {
                                    databaseCRUD.insertSalesReturnCurrentLimit(jsonArrayEmployee);
                                }
                            } else if (objectResponse.has("ishop_pallet_details")) {
                                JSONArray jsonArrayPallet = objectResponse.getJSONArray("ishop_pallet_details");
                                totalRecords = totalRecords + jsonArrayPallet.length();
                                if (jsonArrayPallet != null && jsonArrayPallet.length() > 0) {
                                    databaseCRUD.insertPalletDetails(jsonArrayPallet, dataBaseHelper.getLoginId(),customer_level,role_code);
                                }

                            } else if (objectResponse.has("ishop_extra_pallet_detail")) {
                                JSONArray palletExtraStickerDetail = objectResponse.getJSONArray("ishop_extra_pallet_detail");
                                totalRecords = totalRecords + palletExtraStickerDetail.length();
                                databaseCRUD.InsertPalletExtraStickerDetail(palletExtraStickerDetail);
                            } else if (objectResponse.has("bf_scm_cpm_integration_data")) {
                                JSONArray bfScmList = objectResponse.getJSONArray("bf_scm_cpm_integration_data");
                                totalRecords = totalRecords + bfScmList.length();
                                Log.e("totalRecords--", totalRecords + "");
                                databaseCRUD.insertScmData(bfScmList);
                            }

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * Firing Error on the process of Sync
     * Generally it will fire a broadcast receiver where we handle all the errors
     * in SyncActivity
     */
    private void fireError() {
        ErrorLogHelper.writeToFileMain(exceptionDetails, appVersion, this);
        if (mBinder.isBinderAlive()) {
            Intent intent = new Intent(Content.UPDATE_SYNC_COUNT);
            intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
            intent.putExtra("FLAG", SyncFlag.FLAG_ERROR);
            intent.putExtra("errorCode", error_code);
            intent.putExtra("errorMsg", exceptionDetails);
            intent.putExtra("objProcess", objSyncData.toString());
            intent.putExtra("syncLogID", syncLogID);


            String response = "FLAG!!"+SyncFlag.FLAG_ERROR
                    + "||"
                    +"errorCode!!"+error_code
                    + "||"
                    +"errorMsg!!"+exceptionDetails
                    + "||"
                    +"objProcess!!"+objSyncData
                    + "||"
                    +"syncLogID!!"+syncLogID;
            sendBroadCastDetails(555, "Fail@@"+response, 0);

            sendBroadcast(intent);
        }
    }

    /**
     * Save Data to Database
     */
    private void saveDownloadedData(String downloadFileName) {
        try {
            long ExtractProcess_start = System.currentTimeMillis();
            int totalRecords = 0;
            long SDT_start = System.currentTimeMillis();
            File f = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            LogHelper.printLog("TAG_FILE", "FILE::: " + DownloadFileFromURL.parentpath + "/" + downloadFileName + "/0.txt");
            if (f.exists()) {
                LogHelper.printLog("TAG_FILE", "FILE::: " + f.getAbsolutePath());
                String jsonString = DownloadFileFromURL.readTextFile(f.getPath());

//                JsonObject obj=new JsonParser().parse(DownloadFileFromURL.readTextFile(f.getPath())).getAsJsonObject();
//                saveTempMasterData(obj,downloadFileName,SDT_start);
                if (jsonString != null && !jsonString.isEmpty()) {
                    JSONObject objectResponse = new JSONObject(jsonString);
                    if (objectResponse.getBoolean("status")) {


                        if (objectResponse.has("master_new_customer")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("master_new_customer");
                            Type listType = new TypeToken<ArrayList<CreateNewCustomer>>() {
                            }.getType();
                            List<CreateNewCustomer> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCustomer.clear();
                            DatabaseCRUD.arrayListCustomer.addAll(arrayListTollerDispatchProduct);
                        }
                        tableName = getString(R.string.retailerdispatch);
                        publishProgress(5);
                        if (objectResponse.has("ishop_retailer_dispatch")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch");
                            databaseCRUD.InsertRetailerDispatchNew(jsonArrayEmployee);
                        }

                        tableName = getString(R.string.distributorreturn);
                        publishProgress(36);
                        if (objectResponse.has("ishop_distributor_return")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return");
                            databaseCRUD.InsertDistributorReturnNew(jsonArrayEmployee);
                        }

                        tableName = getString(R.string.distributorreturnrequest);
                        publishProgress(38);

                        if (objectResponse.has("ishop_distributor_return_request")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request");
                            databaseCRUD.InsertDistributorReturnRequestNew(jsonArrayEmployee);
                        }

                        tableName = getString(R.string.cfareturnrequest);
                        publishProgress(42);
                        if (objectResponse.has("ishop_cfa_return")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_return");
                            databaseCRUD.InsertCFAReturnNew(jsonArrayEmployee);
                        }

//                        tableName = getString(R.string.cfareturnrequestproduct);
//                        publishProgress(45);
//                        if (objectResponse.has("ishop_cfa_return_product")) {
//                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_return_product");
//                            databaseCRUD.InsertCFAReturnProductNew(jsonArrayEmployee);
//                        }

                        tableName = getString(R.string.menuaccess);
                        publishProgress(52);
                        if (objectResponse.has("Menu_Access")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Menu_Access");
                            Type listType = new TypeToken<ArrayList<MenuAccess>>() {
                            }.getType();
                            List<MenuAccess> arrayListTollerDispatchProduct = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListMenuAccess.clear();
                            DatabaseCRUD.arrayListMenuAccess.addAll(arrayListTollerDispatchProduct);
                        }

                        tableName = getString(R.string.politicallevel);
                        publishProgress(54);
                        if (objectResponse.has("Political_Level")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Level");
                            Type listType = new TypeToken<ArrayList<PoliticalLevel>>() {
                            }.getType();
                            List<PoliticalLevel> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListPoliticalLevel.clear();
                            DatabaseCRUD.arrayListPoliticalLevel.addAll(arrayListEmployee);
                        }

                        tableName = getString(R.string.distributorreceived);
                        publishProgress(59);
                        if (objectResponse.has("ishop_distributor_received")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received");
                            databaseCRUD.InsertDistributorReceivedNew(jsonArrayEmployee);
                        }
                        tableName = getString(R.string.distributorreceivedproduct);
                        publishProgress(60);
                        if (objectResponse.has("ishop_distributor_received_product")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                            databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                        }
                        tableName = getString(R.string.retailerreceived);
                        publishProgress(62);

                        if (objectResponse.has("ishop_customer_scaned_in_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_in_sticker");
                            Type listType = new TypeToken<ArrayList<ScannedPoints>>() {
                            }.getType();
                            List<ScannedPoints> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListScannedPoints.clear();
                            DatabaseCRUD.arrayListScannedPoints.addAll(arrayListEmployee);
                        }


                        //Used in Both Retailer and Distributor
                        if (objectResponse.has("ishop_customer_scaned_out_sticker")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_customer_scaned_out_sticker");
                            databaseCRUD.insertRetailerScannedOutSticker(jsonArrayEmployee);
                        }

                        tableName = "ctocmapping";
                        publishProgress(63);
                        //CtoCMapping
                        if (objectResponse.has("ctocmapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ctocmapping");
                            Type listType = new TypeToken<ArrayList<CtoCMapping>>() {
                            }.getType();
                            List<CtoCMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCtoCMapping.clear();
                            DatabaseCRUD.arrayListCtoCMapping.addAll(arrayListEmployee);
                        }

                        if (objectResponse.has("ctoemapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ctoemapping");
                            Type listType = new TypeToken<ArrayList<CtoEMapping>>() {
                            }.getType();
                            List<CtoEMapping> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCtoEMapping.clear();
                            DatabaseCRUD.arrayListCtoEMapping.addAll(arrayListEmployee);
                        }

                        if (objectResponse.has("user_configuration_mst")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("user_configuration_mst");
                            Type listType = new TypeToken<ArrayList<UserConfigurationMst>>() {
                            }.getType();
                            List<UserConfigurationMst> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            Log.e("userConfigList", "" + arrayListEmployee);
                            Log.e("userConfigList", "" + jsonArrayEmployee);
                            DatabaseCRUD.arrayListUserConfigurationMst.clear();
                            DatabaseCRUD.arrayListUserConfigurationMst.addAll(arrayListEmployee);
                        }
                        //
                        if (objectResponse.has("Last_Sync_Date_Time")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Last_Sync_Date_Time");
                            databaseHelperExtended.updateLastSyncDateTimeForWHMasterSync(jsonArrayEmployee, 2);
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Content.LAST_SYNC_DATE, jsonArrayEmployee.getJSONObject(0).getString("Last_Sync_Date"));
                        }
                        //table CustomerType_Details
                        if (objectResponse.has("CustomerType_Details")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("CustomerType_Details");
                            Type listType = new TypeToken<ArrayList<CustomerTypeDetails>>() {
                            }.getType();
                            List<CustomerTypeDetails> arrayListEmployee = new Gson().fromJson(jsonArrayEmployee.toString(), listType);
                            DatabaseCRUD.arrayListCustomerType_Details.clear();
                            DatabaseCRUD.arrayListCustomerType_Details.addAll(arrayListEmployee);
                        }
                        tableName = getString(R.string.employeeretailer);
                        publishProgress(67);
                        if (objectResponse.has("etormapping")) {
                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("etormapping");
                            databaseCRUD.InsertETORMAPPINGNew(jsonArrayEmployee);
                        }
                        if (objectResponse.has("rtormapping")) {
                            JSONArray jsonArrayRtoRMapping = objectResponse.getJSONArray("rtormapping");
                            databaseCRUD.InsertRtoRMappingNew(jsonArrayRtoRMapping);
                        }
                        if (objectResponse.has("dtormapping")) {
                            JSONArray jsonArrayDtoRMapping = objectResponse.getJSONArray("dtormapping");
                            databaseCRUD.InsertDtoRMappingNew(jsonArrayDtoRMapping);
                        }

                        databaseCRUD.DumpEmployeeDetails();

                        if (objectResponse.has("isKYCDone")) {
                            Log.d("KYCVAL==", objectResponse.getString("isKYCDone"));
                            String isKYCDone = objectResponse.getString("isKYCDone");
                            //BD
//                            Content.setPreferenceValue(SynchronizationService.this, Const.ISKYCDONE, isKYCDone);
                        }
                    }
                    publishProgress(69);

                    tableName = "VIDEO Detail";
                    if (objectResponse.has("User_Help_Video")) {
                        JSONArray jsonArrayVideo = objectResponse.getJSONArray("User_Help_Video");
                        databaseCRUD.InsertHelpVideoData(jsonArrayVideo, dataBaseHelper.getLoginId(),countryID);
                    }
                    tableName = DataBaseHelper.TABLE_MASTER_REASON;
                    if (objectResponse.has("master_reason")) {
                        JSONArray jsonArrayMasterReason = objectResponse.getJSONArray("master_reason");
                        databaseCRUD.insertMasterReason(jsonArrayMasterReason);
                    }
                    File dir = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName);
                    boolean stickerDetailsStart = false;
                    if (dir.exists() && dir.isDirectory()) {
                        String[] dirs = dir.list();
                        for (String items : dirs) {
                            Log.v("FILE TRACK", " DIRECTORY::" + items);
                            File file = new File(dir.getAbsolutePath() + "/" + items);
                            if (file.isDirectory()) {
                                String[] subDirs = file.list();
                                int count = 92;
                                try {
                                    for (String item : subDirs) {
                                        if (totalProgress < 350) {
                                            totalProgress = totalProgress + 1;
                                        }

                                        Log.v("FILE TRACK", " FILE::" + items);
                                        File tempFile = new File(DownloadFileFromURL.parentpath + "/" + downloadFileName + "/" + items + "/" + item);
                                        String jsonReadText = "";
                                        if (tempFile.exists()) {
                                            jsonReadText = DownloadFileFromURL.readTextFile(tempFile.getPath());
                                        }
                                        if (item.equalsIgnoreCase("1.txt")) {
                                            totalRecords = 1;
                                        }
                                        objectResponse = new JSONObject(jsonReadText);

                                        if (objectResponse.has("ishop_sticker_details")) {
                                            if (!stickerDetailsStart) {
                                                stickerDetailsStart = true;
                                                SDT_start = System.currentTimeMillis();
                                                Log.e("CheckLog", "start" + SDT_start);
                                            }
                                            tableName = getString(R.string.ishopstickerdetails);
                                            ++count;
                                            if (count == 100) {
                                                count = count - 1;
                                            }
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker_details");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            Log.e("CheckLog", "total" + totalRecords);
                                            publishProgress(count);
                                            DatabaseCRUD.InsertStickerDetailsNew(jsonArrayEmployee, SynchronizationService.this, dataBaseHelper.getLoginId(),
                                                    customer_level,role_code);
                                        } else if (objectResponse.has("ishop_cfa_dispatch_product")) {
                                            tableName = getString(R.string.cfadispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(79);
                                            //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch_product");
                                            databaseCRUD.InsertCFADispatchProductNew1(jsonArrayEmployee);

                                        } else if (objectResponse.has("ishop_sample_dispatch_product")) {
                                            tableName = getString(R.string.cfadispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(79);
//                                            String rolecode = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);
                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseHelperExtended.deleteSampleProductTable();
                                            }
                                            databaseCRUD.InsertSampleFocDispatchProduct(jsonArrayEmployee);

                                        } else if (objectResponse.has("customer_details")) {
                                            tableName = getString(R.string.customerdetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("customer_details");
                                            databaseCRUD.insertCustomerDetails(jsonArrayEmployee, item);
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(79);
                                            dataBaseHelper.updateLoginDetails(jsonArrayEmployee, this);
                                        } else if (objectResponse.has("employee_details")) {
                                            tableName = getString(R.string.customerdetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("employee_details");
                                            databaseCRUD.insertEmployeeDetails(jsonArrayEmployee, item);
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(80);
                                        } else if (objectResponse.has("ishop_sticker")) {
                                            tableName = getString(R.string.ishopsticker);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sticker");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(86);

//                                            String customer_level = Content.getPreferenceValue(SynchronizationService.this, Const.CUSTOMER_LEVEL);
//                                            String role_code = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);

                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                            } else if (customer_level.equalsIgnoreCase("L2")) {
                                                databaseCRUD.InsertIshopStickerNew(jsonArrayEmployee);
                                            } else {
                                                databaseCRUD.InsertStickerNew(jsonArrayEmployee, item);
                                            }
                                        } else if (objectResponse.has("ishop_toller_dispatch")) {
                                            tableName = getString(R.string.tollerdispatch);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(86);
                                            DatabaseCRUD.InsertTollerDispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_toller_dispatch_product")) {
                                            tableName = getString(R.string.tollerdispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_toller_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(86);
                                            databaseCRUD.InsertTollerDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_distributor_dispatch_product")) {
                                            tableName = getString(R.string.distributordispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(82);
                                            databaseCRUD.InsertDistributorDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("product_sku_country")) {
                                            tableName = getString(R.string.productskucountry);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_sku_country");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(82);
                                            databaseCRUD.insertProductSkuCountry(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_distributor_return_product")) {
                                            tableName = getString(R.string.distributorreturnproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.InsertDistributorReturnProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_distributor_received_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_received_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(83);
                                            databaseCRUD.InsertDistributorReceivedProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_dispatch_product")) {
                                            tableName = getString(R.string.retailerdispatchproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_dispatch_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(83);
                                            databaseCRUD.InsertRetailerDispatchProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_received_product")) {
                                            tableName = getString(R.string.retailerreceivedproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.InsertRetailerReceivedProductNew(jsonArrayEmployee);
                                        } else if (objectResponse.has("product_type_name_country")) {
                                            tableName = getString(R.string.producttypenamecountry);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("product_type_name_country");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.insertProductTypeNameCountry(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Scheme_Master")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Scheme_Master");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.InsertSchemeMaster(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_cfa_dispatch")) {
                                            tableName = getString(R.string.cfadispatch);
                                            publishProgress(78);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_cfa_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
                                            databaseCRUD.InsertCFADispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_sample_dispatch")) {
                                            tableName = getString(R.string.cfadispatch);
                                            publishProgress(78);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_sample_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(84);
//                                            String rolecode = Content.getPreferenceValue(SynchronizationService.this, Const.ROLE_CODE);
                                            if (role_code.equalsIgnoreCase("FO")) {
                                                databaseHelperExtended.deleteSampleMainTable();
                                            }
                                            databaseCRUD.InsertSampleFocDispatchMain(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("cpm_customer_product_stock")) {
                                            tableName = getString(R.string.customerproductstock);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("cpm_customer_product_stock");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(72);
                                            databaseCRUD.insertCustomerProductStock(jsonArrayEmployee, item);
                                            databaseCRUD.InsertDISPATCHBATCHWISESTOCKCALCULATE(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("cpm_customer_product_damage_stock")) {
                                            tableName = getString(R.string.customerproductstock);
                                            publishProgress(72);
                                            JSONArray jsonArrayDamageStock = objectResponse.getJSONArray("cpm_customer_product_damage_stock");
                                            databaseCRUD.insertCustomerProductDamageStock(jsonArrayDamageStock, item);
                                        } else if (objectResponse.has("ishop_distributor_return_request_product")) {
                                            tableName = getString(R.string.distributorreturnrequestproduct);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_return_request_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
//                                            String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                                            if (customer_level.equalsIgnoreCase("L4")) {
                                                databaseCRUD.InsertDistributorReturnRequestProductNew(jsonArrayEmployee);
                                            } else {
                                                databaseCRUD.InsertDistributorReturnRequestProductNewForDist(jsonArrayEmployee);
                                            }
                                        } else if (objectResponse.has("ishop_distributor_dispatch")) {
                                            tableName = getString(R.string.distributordispatch);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            publishProgress(80);
                                            //                                        JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_distributor_dispatch");
                                            databaseCRUD.InsertDistributorDispatchNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("sales_rep_initiated_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.insertSalesRepInitiatedProduct(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_retailer_received")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_received");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReceivedNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Political_Details")) {
                                            tableName = getString(R.string.politicaldetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertPoliticalDetails(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("Political_Details_Emp")) {
                                            tableName = getString(R.string.politicaldetails);
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("Political_Details_Emp");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertPoliticalDetailsEmp(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("extra_sticker_detail")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("extra_sticker_detail");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertExtraStickerDetail(jsonArrayEmployee);
                                        } else if (objectResponse.has("ishop_retailer_return")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReturnNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("ishop_retailer_return_product")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("ishop_retailer_return_product");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            databaseCRUD.InsertRetailerReturnProductNew(jsonArrayEmployee, item);
                                        } else if (objectResponse.has("sales_rep_initiated_product_current_limit")) {
                                            JSONArray jsonArrayEmployee = objectResponse.getJSONArray("sales_rep_initiated_product_current_limit");
                                            totalRecords = totalRecords + jsonArrayEmployee.length();
                                            if (jsonArrayEmployee.length() > 0) {
                                                databaseCRUD.insertSalesReturnCurrentLimit(jsonArrayEmployee);
                                            }
                                        } else if (objectResponse.has("ishop_pallet_details")) {
                                            JSONArray jsonArrayPallet = objectResponse.getJSONArray("ishop_pallet_details");
                                            totalRecords = totalRecords + jsonArrayPallet.length();
                                            if (jsonArrayPallet.length() > 0) {
                                                databaseCRUD.insertPalletDetails(jsonArrayPallet, dataBaseHelper.getLoginId(),customer_level,role_code);
                                            }

                                        } else if (objectResponse.has("ishop_extra_pallet_detail")) {
                                            JSONArray palletExtraStickerDetail = objectResponse.getJSONArray("ishop_extra_pallet_detail");
                                            totalRecords = totalRecords + palletExtraStickerDetail.length();
                                            databaseCRUD.InsertPalletExtraStickerDetail(palletExtraStickerDetail);
                                        } else if (objectResponse.has("bf_scm_cpm_integration_data")) {
                                            JSONArray bfScmList = objectResponse.getJSONArray("bf_scm_cpm_integration_data");
                                            totalRecords = totalRecords + bfScmList.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.insertScmData(bfScmList);
                                        } else if (objectResponse.has("ishop_cfa_return_product")) {
                                            JSONArray cfaReturnProductArray = objectResponse.getJSONArray("ishop_cfa_return_product");
                                            totalRecords = totalRecords + cfaReturnProductArray.length();
                                            Log.e("totalRecords--", totalRecords + "");
                                            databaseCRUD.InsertCFAReturnProductNew(cfaReturnProductArray);
                                        }

                                    }
                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }
                            }
                        }
                    }


                    if (!error_code.trim().isEmpty()) {
                        updateActivity();
                        return;
                    }

                    dataBaseHelper.deleteSaveOfflineLogTable();
                    databaseCRUD.deleteUnreceivedValidData();
                    databaseCRUD.deleteRejectedOrder();
                    dataBaseHelper.deleteDamageData();
                    databaseCRUD.deleteDeviceTokenTable();
                    databaseHelperExtended.deleteRejectedData();
                    dataBaseHelper.deleteCfaDispatchIDNotInProductTable();
                    databaseHelperExtended.deleteCfaDispatchIDNotInMainTable();
                    databaseHelperExtended.deleteTransactionErrorLog();
                    insertDelayedTransaction();
//                    Content.setPreferenceValue(this, Const.RECEIVE_BY_CONFIRM, "");

//                    String customer_level = Content.getPreferenceValue(this, Const.CUSTOMER_LEVEL);
                    if (customer_level.equalsIgnoreCase("L3")) {
                        databaseHelperExtended.deleteDistributorReturnRequestData(userID);
                    }

                    long SDT_End = System.currentTimeMillis();
                    try {
                        long difference = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        Log.v("SYNCTRACK", "SDT_ TIME::" + difference);
                        objSyncData.put("SDT", "" + difference);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    long ExtractProcess_end = System.currentTimeMillis();
                    long difference = AppUtil.getMillisDifference(ExtractProcess_start, ExtractProcess_end);
                    Log.v("SYNCTRACK", "SYPR_ TIME::" + difference);

                    try {
                        long differenceStickerTable = AppUtil.getMillisDifference(SDT_start, SDT_End);
                        long totalRemaining = difference - differenceStickerTable;
                        objSyncData.put("SYPR", totalRemaining);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

//                    stopTimer();

                    if (isPointCalculationSync) {
                        LogHelper.printLog("TAG_SYNC_DATA", "CALL POINT CALC Webservice");
                        callSchemeAPIPoint(syncFileName, syncLogID, "P");
                    } else {
                        callGetUserCurrentPointsAPI(true);
                    }
                }

            } else {
//                stopTimer();
                exceptionDetails = "Download File do not exist.";
                error_code = "108";

                fireError();
            }
        } catch (JSONException e) {
            e.printStackTrace();
//            stopTimer();
            exceptionDetails = AppUtil.getStackTrace(e);
            error_code = "108";

            fireError();
        }
    }

}
